Attribute VB_Name = "INST_Prozeduren"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   INST_Prozeduren
' Effekt:
'   Das Modul installiert eine neue Version von Gs4Word.
'   Das Add-In installiert je ein Word-, Excel und Powerpoint-Add-In
'   -   Gs4Word.dot (Word)
'   -   Gs4Word.xla (Excel)
'   -   Gs4Word.ppa (Powerpoint)
'   fr die Office-Versionen
'   -   Office  8.0 = Office 97
'   -   Office  9.0 = Office 2000
'   -   Office 10.0 = Office 2002
'
'   Wenn Sie das Installionsscript fr Ihre eigenen Add-Ins verwenden wollen, mssen Sie u.a.
'   den Inhalt der Konstanten sADDIN_NAME anpassen.
' Restriktionen:
'   Alle Module und UserForms GLOB_, INST_, MACH_, REG_ und TECH_ mssen vorhanden sein.
'   Unter Word 9.0 und 10.0 muss die Sicherheitsstufe niedrig oder Mittel sein, damit dieses
'   Add-In ausgefhrt werden kann.
'   Dieses Add-In darf nicht schreibgeschtzt sein. Der Name ist beliebig.
'   Der genaue Name steht in der ThisDocument.Name.
' Entwicklung und Test:
'   siehe Dokumentation
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   10.10.2002  Erweitet fr Version 2.60
'   05.10.2003  Erweitert um Protokollierung aller nderungen in der Konfiguration
'   20.10.2003  Erweitert um Installation eines Druckers und Installation von Ghostscript
'   15.11.2003  Erweitert um Office 2003 - Version 11.0
'   24.05.2004  Fehler bei AddIn.Installed beseitigt
'   21.05.2005  In fiAnzahlInstanzen_ermitteln Geister Tasks auch bei Windows XP und Office 2003
'   26.05.2005  Weitermachen obwohl mehrere Instanzen von Word laufen und fiAnzahlInstanzen_ermitteln berarbeitet

'===================================================================================================
'Deklarationen
'===================================================================================================

' Konstante fr die Sicherheitseinstellungen
'-------------------------------------------
Private Const sSECURITYNAME_LEVEL As String = "Level"
Private Const sSECURITYNAME_ACCESSVBOM As String = "AccessVBOM"
Private Const sSECURITYNAME_DONTTRUST As String = "DontTrustInstalledFiles"
Private Const vSECURITYWERT_LEVEL_1 As Variant = "&H00000001" 'niedriger Sicherheitslevel
Private Const vSECURITYWERT_LEVEL_2 As Variant = "&H00000010" 'mittlerer Sicherheitslevel
Private Const vSECURITYWERT_LEVEL_3 As Variant = "&H00000011" 'hoher Sicherheitslevel
Private Const vSECURITYWERT_ACCESSVBOM As Variant = "&H00000001" ' Zugriff auf Visual-Basic-Objekt vertrauen Aktiv (1!)"
Private Const vSECURITYWERT_DONTTRUST As Variant = "&H00000000" 'Allen installieren Add-Ins vertrauen Aktiv (0!)

' Konstante fr die Funktionen fbInstallieren und fbXXXXAddInErzeugen und der beine UserForms
'--------------------------------------------------------------------------------------------
Public Const iAUFGABE_0 As Integer = 0
    'gbXXXXxxFlag setzen und in gsAktion beschreiben
Public Const iAUFGABE_1 As Integer = 1
    'Schalter zum Erzeugen der Add-Ins setzen
Public Const iAUFGABE_2 As Integer = 2
    'Deinstallation in gsAktion beschreiben
Public Const iAUFGABE_3 As Integer = 3
    ''Wenn ein gbXXXFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
Public Const iAUFGABE_4 As Integer = 4
    'Fr alle gesetzten gsXXXXxxFlag Installation in gsAktion beschreiben
Public Const iAUFGABE_5 As Integer = 5
    'Deinstallation durchfhren und in gsAktion beschreiben
Public Const iAUFGABE_6 As Integer = 6
    'Wenn ein gsXXXXxxFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
Public Const iAUFGABE_7 As Integer = 7
    'Fr alle gesetzten gsXXXXxxFlag Installation durchfhren und in gsAktion beschreiben

'===================================================================================================
'Alle ffentlichen Variablen fr MACH_* und INST_*
'===================================================================================================
Public gsOfficeVersion As String
Public gsWordAddIn As String
Public gsExcelAddIn As String
Public gsPowerpointAddIn As String
Public gsUebersetzungDokument As String

'===================================================================================================
'Alle ffentlichen Variablen nur fr INST_*
'===================================================================================================
Public gbWordFlag As Boolean
Public gbExcelFlag As Boolean
Public gbPowerpointFlag As Boolean
Public gbWordSicherheit As Boolean
Public gbExcelSicherheit As Boolean
Public gbPowerpointSicherheit As Boolean
Public gbKonfAddInErzeugenFlag As Boolean
Public gbWordAddInErzeugenFlag As Boolean
Public gbExcelAddInErzeugenFlag As Boolean
Public gbPowerpointAddInErzeugenFlag As Boolean
Public gbUebersetzungDokErzeugenFlag As Boolean
Public gbKonfAddInErzeugenAenderbar As Boolean
Public gbWordAddInErzeugenAenderbar As Boolean
Public gbExcelAddInErzeugenAenderbar As Boolean
Public gbPowerpointAddInErzeugenAenderbar As Boolean
Public gbUebersetzungDokErzeugenAenderbar As Boolean
Public gsAktion As String
Public gsAktionen(7) As String
Public gbDialogEffekt As Boolean
Public gsOfficeName As String
Public gsArchiv As String
Public gsPowerpointAddInRegistryName As String
Public gsAlteWordAddIns As String
Public gsAlteExcelAddIns As String
Public gsAltePowerpointAddIns As String
Public gsInstLogbuchAufruf As String
Public gsDeInstLogbuchAufruf As String
Public gsInstallationsMailToSwitch As String
Public gbEinRechnerInstallation As Boolean
Public gbDeinstalltionAktivFlag As Boolean
Public gbAnzahlWordInstanzenOKFlag As Boolean

Function fbInstallationPruefen() As Boolean
    'Die Funktion prft nur, ob alle im Zip-Archiv vorhandenen Unterverzeichnisse vorhanden sind.
    'Sie bentigt nichts - noch nicht einmal Sprachtexte
        
    Const sKEINEVERZEICHISSE_DE As String = "Sie haben Gs4Word ohne Unterverzeichnisse entpackt. Stellen Sie Ihr Programm zum Entpacken so ein, dass es auch die Unterzeichnisse entpackt.(&n)(&n)"
    Const sKEINEVERZEICHISSE_EN As String = "You have unpacked Gs4Word without subdirectories. Configure your unzip program to unpack all subdirectories."
    
    Const sVERZEICHNISFEHLT_DE As String = "Gs4Word ist unvollstndig. Es fehlt mindestens das Verzeichnis '(&1=Verzeichnis)'. Verschaffen Sie sich bitte eine vollstndige Version des Programms und versuchen Sie es damit erneut.(&n)(&n)"
    Const sVERZEICHNISFEHLT_EN As String = "Gs4Word is incomplete. At least one directory (&1) is missing. Please try again with a complete version of the program."
    
    Dim sInstVerzeichnis As String
    Dim sVerzeichnisse(3) As String
    Dim vEinVerzeichnis As Variant
    Dim iAnzahlVerzeichnisse As Integer
    
    sInstVerzeichnis = ThisDocument.Path & Application.PathSeparator
    
    'Namen aller Verzeichnisse des Add-In eintragen
    sVerzeichnisse(0) = sSOURCEDIR
    sVerzeichnisse(1) = sKONFIGDIR
    sVerzeichnisse(2) = sDOKDIR
    sVerzeichnisse(3) = sLIZENZDIR
    
    iAnzahlVerzeichnisse = 0
    For Each vEinVerzeichnis In sVerzeichnisse
        If Dir(sInstVerzeichnis & CStr(vEinVerzeichnis), vbDirectory) <> sLEER Then
            iAnzahlVerzeichnisse = iAnzahlVerzeichnisse + 1
        End If
    Next vEinVerzeichnis
    
    Select Case iAnzahlVerzeichnisse
        Case UBound(sVerzeichnisse) + 1
            fbInstallationPruefen = True
        Case 0
            MsgBox fsText(sKEINEVERZEICHISSE_DE & sKEINEVERZEICHISSE_EN) _
                , vbExclamation, sADDIN_NAME & sSPACE & sADDIN_VERSION
            fbInstallationPruefen = False
        Case Else
            MsgBox fsText(sVERZEICHNISFEHLT_DE & sVERZEICHNISFEHLT_EN _
                , sInstVerzeichnis & vEinVerzeichnis _
                , sInstVerzeichnis & vEinVerzeichnis) _
                , vbExclamation, sADDIN_NAME & sSPACE & sADDIN_VERSION
            fbInstallationPruefen = False
    End Select
    
End Function

Function fbSprachtexteErzeugen(sSprachcode As String, sInstVerzeichnis As String) As Boolean

    Call fbGLOB_SprachtexteErzeugen(sSprachcode, sInstVerzeichnis)
    Call fbINST_SprachtexteErzeugen(sSprachcode, sInstVerzeichnis)
    Call fbMACH_SprachtexteErzeugen(sSprachcode, sInstVerzeichnis)
    Call fbTECH_SprachtexteErzeugen(sSprachcode, sInstVerzeichnis)
    fbSprachtexteErzeugen = True

End Function

Function fbInstallation_durchfhren() As Boolean
    'Die Funktion installiert Gs4Word
    'Sie wird von INST_Schnittstellen.* aufgerufen
    
    gbDeinstalltionAktivFlag = False
    
    If fbInstallieren(iAUFGABE_0) = True Then
        If fbInstallationsdateienPruefen(gsOfficeVersion) = True Then
            If fbKonfiguration_mitTechnikDefaultsBelegen = True Then
                If gsMailtoParameter = sLEER Then
                    gsInstallationsMailToSwitch = fsMailToSwitch_konvertieren(sDEFAULT_MAILTOSWITCH_NEIN)
                Else
                    gsInstallationsMailToSwitch = fsMailToSwitch_konvertieren(sDEFAULT_MAILTOSWITCH_JA)
                End If
                INST_UF_Installation.Show
            End If
        End If
    End If
    
End Function

Function fbDeinstallation_durchfhren() As Boolean
    'Die Funktion deinstalliert Gs4Word
    'Sie wird von INST_Schnittstellen.* aufgerufen
    
    gbDeinstalltionAktivFlag = True
    
    If fbInstallieren(iAUFGABE_0) = True Then
        If fbKonfiguration_mitTechnikDefaultsBelegen = True Then
            INST_UF_Deinstallation.Show
        End If
    End If
    
End Function

Function fbInstallieren(iAufgabe As Integer) As Boolean
    'Die Funktion installiert in drei Aufrufen alle Add-Ins.
    'Argumente:
    '   iAufgabe siehe Deklaration iAUFGABE_n
    'Global:
    '   siehe fbWord_installieren, fbExcel_installieren und fbPowerpoint_installieren
    
    Dim iZaehler As Integer
    Dim iAnzahlInstallationen As Integer
    Dim lPos As Long
    Dim sWindowsName As String
    Dim sRechnerName As String
    Dim sLandName As String
    Dim bAktion As Byte
    Dim sGhostscriptVersion As String
     
    fbInstallieren = False

    
    Select Case iAufgabe
    Case iAUFGABE_0 'gbWordFlag setzen und in gsAktion beschreiben
        For iZaehler = LBound(gsAktionen) To UBound(gsAktionen)
            gsAktionen(iZaehler) = sLEER
        Next iZaehler
        gsPathSeparator = Application.PathSeparator 'PathSeparator IMMER neu ermitteln
        gsInstVerzeichnis = ThisDocument.Path & gsPathSeparator
        sRechnerName = fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, _
            "SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName", "ComputerName", _
            NEVER_RETURN_NULL)
        If Trim(sRechnerName) = sLEER Then
            sRechnerName = "NoName"
        End If
        gsInstLogbuch = gsInstVerzeichnis & "Installation_" & sRechnerName & sTXT
        gsDeInstLogbuch = gsInstVerzeichnis & "InstallationUndDeinstallation_" & sRechnerName & sTXT
        gsInstLogbuchAufruf = fsVerknuepfung_ermitteln(sTXT, gsInstLogbuch)
        gsDeInstLogbuchAufruf = fsVerknuepfung_ermitteln(sTXT, gsDeInstLogbuch)
        iAnzahlInstallationen = fiAnzahlInstallationslogbuecher
        If iAnzahlInstallationen = 0 Then
            gbEinRechnerInstallation = True
        Else
            gbEinRechnerInstallation = False
        End If
        gsAlteWordAddIns = sADDIN_NAME & "*.dot"
        gsAlteExcelAddIns = sADDIN_NAME & "*.xla"
        gsAltePowerpointAddIns = sADDIN_NAME & "*.ppa"
        gsArchiv = sADDIN_NAME & "_" & sADDIN_VERSION
        gsWordAddIn = sADDIN_NAME & ".dot"
        gsExcelAddIn = sADDIN_NAME & ".xla"
        gsPowerpointAddIn = sADDIN_NAME & ".ppa"
        gsPowerpointAddInRegistryName = sADDIN_NAME
        gsUebersetzungDokument = "Uebersetzung.doc"
        gbAnzahlWordInstanzenOKFlag = False

        Select Case Val(Word.Application.Version)
        Case 8
            gsOfficeVersion = "8.0"
            gsOfficeName = "Microsoft Office 97"
            'Hinweis wenn Windows NT, 2000 oder XP und Office97 ohne SR2
            'Siehe Microsoft Knowledge Base D38624 und D40060
            'Ebenfalls Hinweis bei Windows 95/98/ME anzeigen
            'If Word.Application.Version <> "8.0b" Then
            '    MsgBox fsText(sMSG_OFFICE97OHNESP2) _
            '        , vbInformation, sTITEL_INSTALLIEREN
            'End If
        Case 9
            gsOfficeVersion = "9.0"
            gsOfficeName = "Microsoft Office 2000"
        Case 10
            gsOfficeVersion = "10.0"
            gsOfficeName = "Microsoft Office 2002"
         Case 11
            gsOfficeVersion = "11.0"
            gsOfficeName = "Microsoft Office 2003"
        Case Else
            MsgBox fsText(sMSG_OFFICEVERSIONUNBEKANNT _
                , Word.Application.Version) _
                , vbExclamation, sTITEL_INSTALLIEREN
            Exit Function
        End Select
        
        gsAktion = String(120, "-") _
            & vbCr & Format(Date, "Long Date") & sSPACE & Format(Time, "Long Time") & sSPACE _
            & sTITEL_LOGBUCH & vbCr
        gsAktion = gsAktion & vbCr
        gsAktion = gsAktion & sTXT_KENNDATENSYSTEM & vbCr
        gsAktion = gsAktion & fsText(sTXT_RECHNER, sRechnerName) & vbCr
        gsAktion = gsAktion & fsText(sTXT_PROZESSOR, System.ProcessorType) & vbCr
        gsAktion = gsAktion & fsText(sTXT_AUFLOESUNG, System.HorizontalResolution, _
            System.VerticalResolution) & vbCr
        sWindowsName = System.OperatingSystem
        Select Case LCase(System.OperatingSystem)
        Case "windows"
            'Windows Plattform 1
            Select Case Left(System.Version, 3)
            Case "4.0"
                sWindowsName = "Windows 95"
            Case "4.1"
                sWindowsName = "Windows 98"
            Case "4.9"
                sWindowsName = "Windows ME"
            End Select
        Case "windows nt"
            'Windows Plattform 2,
            Select Case Left(System.Version, 3)
            Case "3.5"
                sWindowsName = "Windows NT 3.51" 'Ungetestet; wer hat noch NT 3.51 ?
            Case "4.0"
                sWindowsName = "Windows NT 4.0"
            Case "5.0"
                sWindowsName = "Windows 2000"
            Case "5.1"
                sWindowsName = "Windows XP"
            End Select
        End Select
        gsAktion = gsAktion & fsText(sTXT_BETRIEBSSYSTEM, sWindowsName, System.Version) & vbCr
        Select Case System.Country
            Case wdArgentina
                sLandName = "Argentina"
            Case wdBrazil
                sLandName = "Brazil"
            Case wdCanada
                sLandName = "Canada"
            Case wdChile
                sLandName = "Chile"
            Case wdChina
                sLandName = "China"
            Case wdDenmark
                sLandName = "Denmark"
            Case wdFinland
                sLandName = "Finland"
            Case wdFrance
                sLandName = "France"
            Case wdGermany
                sLandName = "Germany"
            Case wdIceland
                sLandName = "Iceland"
            Case wdItaly
                sLandName = "Italy"
            Case wdJapan
                sLandName = "Japan"
            Case wdKorea
                sLandName = "Korea"
            Case wdLatinAmerica
                sLandName = "LatinAmerica"
            Case wdMexico
                sLandName = "Mexico"
            Case wdNetherlands
                sLandName = "Netherlands"
            Case wdNorway
                sLandName = "Norway"
            Case wdPeru
                sLandName = "Peru"
            Case wdSpain
                sLandName = "Spain"
            Case wdSweden
                sLandName = "Sweden"
            Case wdTaiwan
                sLandName = "Taiwan"
            Case wdUK
                sLandName = "UK"
            Case wdUS
                sLandName = "US"
            Case wdVenezuela
                sLandName = "Venezuela"
            Case Else
                sLandName = System.Country
        End Select
        gsAktion = gsAktion & fsText(sTXT_LAND, sLandName) & vbCr
        gsAktion = gsAktion & fsText(sTXT_SPRACHE, System.LanguageDesignation) & vbCr
        gsAktion = gsAktion & vbCr
        gsAktion = gsAktion & sTXT_KENNDATENINST & vbCr
        gsAktion = gsAktion & fsText(sTXT_OFFICE, gsOfficeName, Word.Application.Version) & vbCr
        gsAktion = gsAktion & fsText(sTXT_ADDIN, sADDIN_NAME, sADDIN_VERSION) & vbCr
        gsAktion = gsAktion & fsText(sTXT_INSTVERZEICHNIS, gsInstVerzeichnis) & vbCr
        gsAktion = gsAktion & fsText(sTXT_INSTADDIN, ThisDocument.Name) & vbCr
        gsAktion = gsAktion & fsText(sTXT_ANZAHLINSTALLATIONEN, iAnzahlInstallationen + 1) & vbCr
        
    Case iAUFGABE_1 'Schalter setzen
        gsAktion = vbCr
    Case iAUFGABE_2 'Deinstallation in gsAktion beschreiben
        gsAktion = sTXT_AKTION_2 & vbCr
    Case iAUFGABE_3 'fr alle gesetzten gsXXXXxxFlag Erzeugen der AddIns in gsAktion beschreiben
        gsAktion = sTXT_AKTION_3 & vbCr
    Case iAUFGABE_4 'fr alle gesetzten gsXXXXxxFlag Installation in gsAktion beschreiben
        gsAktion = sTXT_AKTION_4 & vbCr
    Case iAUFGABE_5 'Deinstallation durchfhren und in gsAktion beschreiben
        gsAktion = sTXT_AKTION_5 & vbCr
    Case iAUFGABE_6 'fr alle gesetzten gsXXXXxxFlag Add-Ins erzeugen und in gsAktion beschreiben
        gsAktion = sTXT_AKTION_6 & vbCr
        'In diesem Schritt werden die Add-Ins erzeugt. Vorher die sprachabhngigen Sourcen erzeugen
        If gbDebugFlag = True Then
            bAktion = bERZEUGE_AUS_RUNTIME_MIT_TRACE
        Else
            bAktion = bERZEUGE_AUS_RUNTIME
        End If
        'Ein AddIn ist zwar immer aktiv - Dieser If errinnert daran, dass es nicht so sein muss
        If gbKonfAddInErzeugenFlag = True _
        Or gbWordAddInErzeugenFlag = True _
        Or gbExcelAddInErzeugenFlag = True _
        Or gbPowerpointAddInErzeugenFlag = True Then
            'Jetzt alle sprachabhngigen Sourcen neu erzeugen
            If fbSprachsourcenErzeugen(bAktion, sLEER) = False Then
                Exit Function
            End If
        End If

    Case iAUFGABE_7 'fr alle gesetzten gsXXXXxxFlag Installation durchfhren und in gsAktion beschreiben
        gsAktion = sTXT_AKTION_7 & vbCr
        'AusgabeMedienTabelle noch einmal fllen
        'Das wurde zwar schon zu Beginn der Installation in fbKonfiguration_mitTechnikDefaultsBelegen
        'gemacht. Es kann sein, dass Ghostscript erst im Laufe der Installation gesetzt oder
        'verndert wurde.
        gsGSParamKonfName = fsGSParamKonfigName_ermitteln()
        'AusgabeMedienTabelle fllen
        Call fbParamTabelleFuellen(gsGSParamKonfName)
        Call fbAusgabeMedienTabelle_DefaultFuellen
        
    End Select

    If fbDrucker_installieren(iAufgabe, gsOfficeVersion, bAktion) = True Then
        If fbGhostscript_installieren(iAufgabe, gsOfficeVersion, bAktion) = True Then
            If fbPDFBetrachter_installieren(iAufgabe, gsOfficeVersion, bAktion) = True Then
                If fbWord_installieren(iAufgabe, gsOfficeVersion, bAktion) = True Then
                    If fbExcel_installieren(iAufgabe, gsOfficeVersion, bAktion) = True Then
                        If fbPowerpoint_installieren(iAufgabe, gsOfficeVersion, bAktion) = True Then
                            If fbUebersetzungsdokument_installieren(iAufgabe, gsOfficeVersion, bAktion) = True Then
                                fbInstallieren = True
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
    
    If InStr(gsAktion, vbCr) = Len(gsAktion) Then
        ' Nur eine Zeile bedeutet, dass keine weiteren Informationen vorhanden sind
        gsAktionen(iAufgabe) = sLEER
    Else
        gsAktionen(iAufgabe) = gsAktion & vbCr
    End If
    
End Function

Function fbAddIn_deaktivieren() As Boolean
    Dim oEinAddIn As Object
    For Each oEinAddIn In AddIns
        If oEinAddIn.Installed = True Then
            If LCase(Left(oEinAddIn.Name, 7)) = sADDIN_NAME & "_" Then
                oEinAddIn.Installed = False
            End If
        End If
    Next oEinAddIn
    fbAddIn_deaktivieren = True
End Function

Function fbLogbuch_schreiben() As Boolean
    'Die Funktion ergnzt das Installationslogbuch im Installationsverzeichnis um die neue
    'Installation
    'Global:
    '   gsInstLogbuch wird gelesen
    '   gsAktionen wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim vEineAktion As Variant
    Dim lPos As Long
    Dim iDateinummer As Integer
    
    'Falls nur ein DeinstallationsLogbuch vorhanden ist, wir es umbenannt
    If Dir(gsDeInstLogbuch, vbNormal) <> sLEER _
    And Dir(gsInstLogbuch, vbNormal) = sLEER Then
        If fbDatei_kopieren(gsDeInstLogbuch, gsInstLogbuch) = True Then
            Call fbDatei_loeschen(gsDeInstLogbuch)
        End If
    End If
    
    iDateinummer = FreeFile
    Open gsInstLogbuch For Append Access Write Lock Read Write As #iDateinummer
    
    For Each vEineAktion In gsAktionen
        Do While vEineAktion <> sLEER
            lPos = InStr(1, vEineAktion, vbCr)
            Print #iDateinummer, Left(vEineAktion, lPos - 1)
            vEineAktion = Mid(vEineAktion, lPos + 1)
        Loop
    Next vEineAktion
    
    Print #iDateinummer, sLEER

    Close #iDateinummer
    
    fbLogbuch_schreiben = True

End Function

Function fbProtokoll_UmRegistryErgaenzen() As Boolean
    'Die Funktion ergnzt das Installationslogbuch im Installationsverzeichnis um die Eintrge
    'fr Gs4Word in der Registry
    'Global:
    '   gsInstLogbuch wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner

    Dim sVBAPfad As String
    Dim lPfadIndex As Long
    Dim vSubPfadName As Variant
    Dim sWertPfad As String
    Dim lWertIndex As Long
    Dim vWertName As Variant
    Dim sWertName As String
    Dim sWert As String
    Dim iDateinummer As Integer

    sVBAPfad = sREGISTRY_VBANAME & "\" & sREGISTRY_APPNAME

    iDateinummer = FreeFile
    Open gsInstLogbuch For Append Access Write Lock Read Write As #iDateinummer

    Print #iDateinummer, String(120, "-")
    Print #iDateinummer, Format(Date, "Long Date") & sSPACE & Format(Time, "Long Time") _
        & sSPACE & sTITEL_INSTALLIEREN
    Print #iDateinummer, ""
    Print #iDateinummer, sTXT__REGISTRY

    lPfadIndex = 0
    Do While True
        vSubPfadName = fvRegistry_SubPfadNummerLesen(HKEY_CURRENT_USER, sVBAPfad, lPfadIndex)
        If IsNull(vSubPfadName) = True Then 'fertig
            Exit Do
        End If
        sWertPfad = sVBAPfad & "\" & CStr(vSubPfadName)
        Print #iDateinummer, "    " & sTXT__SCHLUESSEL; sWertPfad

        lWertIndex = 0
        Do While True
            vWertName = fvRegistry_WertNummerLesen(HKEY_CURRENT_USER, sWertPfad, lWertIndex)
            If IsNull(vWertName) = True Then 'fertig
                Exit Do
            End If
            sWertName = CStr(vWertName)
            sWert = fvRegistry_WertLesen(HKEY_CURRENT_USER, sWertPfad, sWertName, NEVER_RETURN_NULL)
            Print #iDateinummer, "        " & sWertName & " = " & sWert
            If sWertName = "printer_name" Then 'sREGISTRY_KEY_PSDRUCKERNAME
                Print #iDateinummer, "        " & "(Port" & " = " & fsDruckerPort_ermitteln(gsPSDruckerName) & ")"
            End If
            lWertIndex = lWertIndex + 1
        Loop
        lPfadIndex = lPfadIndex + 1
    Loop

    Close #iDateinummer

    fbProtokoll_UmRegistryErgaenzen = True

End Function

Function fiAnzahlInstallationslogbuecher() As Integer
    'Die Funktion zhlt die Anzahl der zustzlichen Installatonslogbcher in Installationsverzeichnis
    'Global:
    '   gsInstLogbuch wird gelesen
    'Rckgabewert:
    '   Anzahl der Installationslgbcher
    'Effekt
    '   keiner
    
    Dim sInstlogbuch As String
    Dim sDatei As String
    
    fiAnzahlInstallationslogbuecher = 0

    sInstlogbuch = gsInstVerzeichnis & "Installation_*" & sTXT
    sDatei = Dir(sInstlogbuch, vbNormal)
    Do While sDatei <> ""
        If LCase(gsInstVerzeichnis & sDatei) <> LCase(gsInstLogbuch) Then
            fiAnzahlInstallationslogbuecher = fiAnzahlInstallationslogbuecher + 1
        End If
        sDatei = Dir ' Nchsten Eintrag abrufen.
    Loop

End Function

Function fbDrucker_installieren(iAufgabe As Integer, sOfficeVersion As String, bAktion As Byte) As Boolean
    'Die Funktion installiert in drei Aufrufen ggf. Port gsNeuerPortName
    'und den Drucker 'sGS4WORDPOSTSCRIPTPRINTER & sSPACE & sDruckertreiber'.
    'Argumente:
    '   iAufgabe siehe Deklaration iAUFGABE_n
    '   sOfficeVersion ist die Versionsnummer von Office
    '   bAktion = Aktion beim Erzeugen des Add-In
    '       bERZEUGE_AUS_RUNTIME oder bERZEUGE_AUS_RUNTIME_MIT_TRACE
    'Global:
    '   sGS4WORDPOSTSCRIPTPRINTER wird gelesen
    '   gbRedmonFlag wird gelesen
    '   gsNeuerPortName wird gelesen
    '   gsNeuerPortName wird gelesen
    '   gbPrnadminFlag wird gelesen
    '   giPrnadminInstallationsstatus wird gelesen
    '       0 = Port NUL: ist vorhanden
    '       1 = installiert, aber Port NUL: fehlt
    '       2 = nicht installiert, kann aber installiert werden
    '       3 = kann nicht installiert werden
    '   gbRedmonFlag wird gelesen
    '   giRedmonInstallationsstatus wird gelesen
    '       0 = installiert und Port GS4WORD: ist vorhanden
    '       1 = installiert, aber Port Gs4WORD: fehlt
    '       2 = nicht installiert, kann aber installiert werden
    '       3 = nicht entpackt, kann aber entpackt und installiert werden
    '       4 = kann nicht installiert werden
    '   gsPSDruckerName wird neu gefllt
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    
    Const sPREFIX As String = "    Drucker: "
       
    Dim sText As String
    Dim sDruckertreiber As String
    Dim sDruckername As String
    Dim sDialogInstallationsText As String
                      
    fbDrucker_installieren = False
    
    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case iAUFGABE_0 'gbWordFlag und Sicherheitsflag setzen und in gsAktion beschreiben
    Case iAUFGABE_1 'Schalter zum Erzeugen der Add-Ins setzen
    Case iAUFGABE_2 'Deinstallation in gsAktion beschreiben
    Case iAUFGABE_3 '
    Case iAUFGABE_4 'Wenn ein neuer Drucker installiert werden soll Installation in gsAktion beschreiben
                      
        If gbPrnadminFlag = True Then
            If giPrnadminInstallationsstatus = 2 Then
                'Installation beschreiben
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_PRNADMININSTALLIEREN _
                        , sPORTNUL) & vbCr
            End If
            If giPrnadminInstallationsstatus = 1 _
            Or giPrnadminInstallationsstatus = 2 Then
                'Installation beschreiben
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_PORTANLEGEN _
                        , sPORTNUL) & vbCr
            End If
            If giPrnadminInstallationsstatus = 2 Then
                'DEInstallation beschreiben
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_PRNADMINDEINSTALLIEREN _
                        , sPORTNUL) & vbCr
            End If
        End If
            
        If gbRedmonFlag = True Then
            If giRedmonInstallationsstatus = 3 Then
                'Entpacken beschreiben
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_REDMONENTPACKEN _
                        , sPORTGS4WORD) & vbCr
            End If
            
            If giRedmonInstallationsstatus = 2 _
            Or giRedmonInstallationsstatus = 3 Then
                'Installation beschreiben
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_REDMONINSTALLIEREN _
                        , sPORTGS4WORD) & vbCr
            End If
            
            If giRedmonInstallationsstatus = 1 _
            Or giRedmonInstallationsstatus = 2 _
            Or giRedmonInstallationsstatus = 3 Then
                'Installation beschreiben
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_PORTANLEGEN _
                        , sPORTGS4WORD) & vbCr
            End If
        End If
            
        If gsNeuerPortName <> sLEER Then
            sDruckertreiber = fsDruckerInstallieren_ermitteln(gsPSDruckerName)
            If sDruckertreiber <> sLEER Then
                'Installation beschreiben
                If fsDialogDruckerInstallationstext_ermitteln(gsPSDruckerName, gsNeuerPortName) <> sLEER Then
                    'Installation im Dialog: Windows 95, 98, ME, NT
                    sDruckername = sDruckertreiber
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT__PSDRUCKERINSTALLIEREN_1 _
                            , sDruckername, gsNeuerPortName) & vbCr
                Else
                    'Installation automatisch: Windows 2000, XP
                    sDruckername = sGS4WORDPOSTSCRIPTPRINTER & sSPACE & sDruckertreiber
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT__PSDRUCKERINSTALLIEREN_2 _
                            , sDruckername, gsNeuerPortName) & vbCr
                End If
            End If
        End If
    Case iAUFGABE_5 'Deinstallation durchfhren und in gsAktion beschreiben
    Case iAUFGABE_6 'Wenn gbWordFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
    Case iAUFGABE_7 'Wenn Wenn ein neuer Drucker installiert werden soll Installation durchfhren und in gsAktion beschreiben
                
        If gbPrnadminFlag = True Then
            If giPrnadminInstallationsstatus = 1 _
            Or giPrnadminInstallationsstatus = 2 Then
                sText = fsPortNUL_installieren
                If sText = sLEER Then
                    If giPrnadminInstallationsstatus = 2 Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_PRNADMINWURDEINSTALLIERT _
                                , sPORTNUL) & vbCr
                    End If
                    If giPrnadminInstallationsstatus = 1 _
                    Or giPrnadminInstallationsstatus = 2 Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_PORTWURDEANGELEGT _
                                , sPORTNUL) & vbCr
                    End If
                    If giPrnadminInstallationsstatus = 2 Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_PRNADMINWURDEDEINSTALLIERT _
                                , sPORTNUL) & vbCr
                    End If
                Else
                    'Fehler:
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
        End If
                
        If gbRedmonFlag = True Then
            If giRedmonInstallationsstatus = 1 _
            Or giRedmonInstallationsstatus = 2 _
            Or giRedmonInstallationsstatus = 3 Then
                sText = fsRedmonPortGS4WORD_installieren
                If sText = sLEER Then
                    If giRedmonInstallationsstatus = 3 Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_REDMONWURDEENTPACKT _
                                , sPORTGS4WORD) & vbCr
                    End If
                    
                    If giRedmonInstallationsstatus = 2 _
                    Or giRedmonInstallationsstatus = 3 Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_REDMONWURDEINSTALLIERT _
                                , sPORTGS4WORD) & vbCr
                    End If
                    
                    If giRedmonInstallationsstatus = 1 _
                    Or giRedmonInstallationsstatus = 2 _
                    Or giRedmonInstallationsstatus = 3 Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_PORTWURDEANGELEGT _
                                , sPORTGS4WORD) & vbCr
                    End If
                Else
                    'Fehler:
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
        End If
            
        If gsNeuerPortName <> sLEER Then
            sDruckertreiber = fsDruckerInstallieren_ermitteln(gsPSDruckerName)
            sDialogInstallationsText = fsDialogDruckerInstallationstext_ermitteln(gsPSDruckerName, gsNeuerPortName)
            If sDruckertreiber <> sLEER Then
                If sDialogInstallationsText <> sLEER Then
                    'Installation im Dialog: Windows 95, 98, ME, NT
                    sDruckername = sDruckertreiber
                    sText = fsNeuenDrucker_installieren_dialog(sDruckername, sDialogInstallationsText, gsNeuerPortName)
                Else
                    'Installation automatisch: Windows 2000, XP
                    sDruckername = sGS4WORDPOSTSCRIPTPRINTER & sSPACE & sDruckertreiber
                    sText = fsNeuenDrucker_installieren_auto(sDruckername, sDruckertreiber, gsNeuerPortName)
                End If
                If sText = sLEER Then
                    'Drucker eintragen
                    gsPSDruckerName = sDruckername
                    'Installation beschreiben
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT__PSDRUCKERWURDEINSTALLIERT _
                            , sDruckername, gsNeuerPortName) & vbCr
                Else
                    'Fehler:
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
                
            End If
        End If
    
    End Select
    
    fbDrucker_installieren = True

End Function

Function fbGhostscript_installieren(iAufgabe As Integer, sOfficeVersion As String, bAktion As Byte) As Boolean
    'Die Funktion registriert in drei Aufrufen ggf. Ghostscript in der Registry.
    'Argumente:
    '   iAufgabe siehe Deklaration iAUFGABE_n
    '   sOfficeVersion ist die Versionsnummer von Office
    '   bAktion = Aktion beim Erzeugen des Add-In
    '       bERZEUGE_AUS_RUNTIME oder bERZEUGE_AUS_RUNTIME_MIT_TRACE
    'Global:
    '   gsDefaultGhostscriptTabelle wird gelesen
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Const sPREFIX As String = "    Ghostscript: "
       
    Dim sText As String
    Dim sPfad As String
    Dim iZaehler As Integer
                  
    fbGhostscript_installieren = False

    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case iAUFGABE_0 'gbWordFlag und Sicherheitsflag setzen und in gsAktion beschreiben
    Case iAUFGABE_1 'Schalter zum Erzeugen der Add-Ins setzen
    Case iAUFGABE_2 'Deinstallation in gsAktion beschreiben
    
        If gbDeinstalltionAktivFlag = True Then
            'Diese Aufgabe wird nur bei der Deinstallation ausgefhrt
            For iZaehler = LBound(gsDefaultGhostscriptTabelle, 1) To UBound(gsDefaultGhostscriptTabelle, 1)
                If LCase(gsDefaultGhostscriptTabelle(iZaehler, 6)) = True _
                And LCase(gsDefaultGhostscriptTabelle(iZaehler, 4)) = True Then
                    gsAktion = gsAktion & sPREFIX & fsText(sTXT_GHOSTSCRIPTDEREGISTRIEREN _
                            , gsDefaultGhostscriptTabelle(iZaehler, 0)) & vbCr
                End If
            Next iZaehler
        End If
    
    Case iAUFGABE_3 '
    Case iAUFGABE_4 'Wenn Ghostscript installiert werden soll Installation in gsAktion beschreiben
           
        iZaehler = fiGhostscriptDefaultNr_ermitteln(gsGSProgrammName, 1)
        If gsDefaultGhostscriptTabelle(iZaehler, 5) <> sLEER Then
            'Entpacken beschreiben
            gsAktion = gsAktion & sPREFIX & fsText(sTXT_GHOSTSCRIPTENTPACKEN _
                    , gsDefaultGhostscriptTabelle(iZaehler, 0)) & vbCr
        End If
        If gsDefaultGhostscriptTabelle(iZaehler, 4) = False Then
            'Installation beschreiben
            gsAktion = gsAktion & sPREFIX & fsText(sTXT_GHOSTSCRIPTREGISTRIEREN _
                    , gsDefaultGhostscriptTabelle(iZaehler, 0)) & vbCr
        End If
    Case iAUFGABE_5 'Deinstallation durchfhren und in gsAktion beschreiben
    
        If gbDeinstalltionAktivFlag = True Then
            'Diese Aufgabe wird nur bei der Deinstallation ausgefhrt
            For iZaehler = LBound(gsDefaultGhostscriptTabelle, 1) To UBound(gsDefaultGhostscriptTabelle, 1)
                If LCase(gsDefaultGhostscriptTabelle(iZaehler, 6)) = True _
                And LCase(gsDefaultGhostscriptTabelle(iZaehler, 4)) = True Then
                    sPfad = "SOFTWARE\" & gsDefaultGhostscriptTabelle(iZaehler, 2) & "\" & gsDefaultGhostscriptTabelle(iZaehler, 3)
    
                    If fbRegistry_PfadPruefen(HKEY_LOCAL_MACHINE, sPfad) = True Then
                        If fbRegistry_PfadLoeschen(HKEY_LOCAL_MACHINE, sPfad) = True Then
                            gsAktion = gsAktion & sPREFIX & fsText(sTXT_GHOSTSCRIPTWURDEDEREGISTRIERT _
                                , gsDefaultGhostscriptTabelle(iZaehler, 0)) & vbCr
                        Else
                            'Fehler: Ghostscript konnte nicht aus der Registry gelscht werden
                            sText = fsText(sMSG_KONNTEGHOSTSCRIPTNICHTDEREGISTRIEREN, gsDefaultGhostscriptTabelle(iZaehler, 0))
                            gsAktion = gsAktion & sPREFIX & sText & vbCr
                            MsgBox sText, vbExclamation, sTITEL_DEINSTALLIEREN
                            Exit Function
                        End If
                    End If
                End If
            Next iZaehler
        End If
    
    Case iAUFGABE_6 'Wenn gbWordFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
    Case iAUFGABE_7 'Wenn Ghostscript installiert werden soll Installation durchfhren und in gsAktion beschreiben
        
        iZaehler = fiGhostscriptDefaultNr_ermitteln(gsGSProgrammName, 1)
        If gsDefaultGhostscriptTabelle(iZaehler, 5) <> sLEER Then
            'Aktion durchfhren
            sText = fsGhostscriptProgramm_entpacken(gsGSProgrammName)
            If sText = sLEER Then
                gsAktion = gsAktion & sPREFIX & fsText(sTXT_GHOSTSCRIPTWURDEENTPACKT _
                    , gsDefaultGhostscriptTabelle(iZaehler, 0)) & vbCr
            Else
                'Fehler: Add-In konnte nicht entpackt werden
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
        If gsDefaultGhostscriptTabelle(iZaehler, 4) = False Then
            'Aktion durchfhren
            sText = fsGhostscriptProgramm_registrieren()
            If sText = sLEER Then
                gsAktion = gsAktion & sPREFIX & fsText(sTXT_GHOSTSCRIPTWURDEREGISTRIERT _
                    , gsDefaultGhostscriptTabelle(iZaehler, 0)) & vbCr
            Else
                'Fehler: Ghostscript konnte nicht registriert werden
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
            
    End Select
    
    fbGhostscript_installieren = True

End Function


Function fbPDFBetrachter_installieren(iAufgabe As Integer, sOfficeVersion As String, bAktion As Byte) As Boolean
    'Die Funktion registriert in drei Aufrufen ggf. den PDF-Betrachter in der Registry.
    'Argumente:
    '   iAufgabe siehe Deklaration iAUFGABE_n
    '   sOfficeVersion ist die Versionsnummer von Office
    '   bAktion = Aktion beim Erzeugen des Add-In
    '       bERZEUGE_AUS_RUNTIME oder bERZEUGE_AUS_RUNTIME_MIT_TRACE
    'Global:
    '   gsDefaultPDFBetrachterTabelle wird gelesen
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Const sPREFIX As String = "    PDF-Betrachter: "
       
    Dim sText As String
    Dim sPfad As String
    Dim iZaehler As Integer
                  
    fbPDFBetrachter_installieren = False

    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case iAUFGABE_0 'gbWordFlag und Sicherheitsflag setzen und in gsAktion beschreiben
    Case iAUFGABE_1 'Schalter zum Erzeugen der Add-Ins setzen
    Case iAUFGABE_2 'Deinstallation in gsAktion beschreiben
'
'        If gbDeinstalltionAktivFlag = True Then
'            'Diese Aufgabe wird nur bei der Deinstallation ausgefhrt
'            For iZaehler = LBound(gsDefaultPDFBetrachterTabelle, 1) To UBound(gsDefaultPDFBetrachterTabelle, 1)
'                If LCase(gsDefaultPDFBetrachterTabelle(iZaehler, 6)) = True _
'                And LCase(gsDefaultPDFBetrachterTabelle(iZaehler, 4)) = True Then
'                    gsAktion = gsAktion & sPREFIX & fsText(sTXT_GHOSTVIEWDEREGISTRIEREN _
'                            , gsDefaultPDFBetrachterTabelle(iZaehler, 0)) & vbCr
'                End If
'            Next iZaehler
'        End If
'
    Case iAUFGABE_3 '
    Case iAUFGABE_4 'Wenn ein PDF-Betrachter installiert werden soll Installation in gsAktion beschreiben
        
        
        iZaehler = fiPDFBetrachterDefaultNr_ermitteln(gsPDFProgrammName, 1)
        If gsDefaultPDFBetrachterTabelle(iZaehler, 5) <> sLEER Then
            'Entpacken beschreiben
            gsAktion = gsAktion & sPREFIX & fsText(sTXT_PDFBETRACHTERENTPACKEN _
                    , gsDefaultPDFBetrachterTabelle(iZaehler, 0)) & vbCr
        End If
    Case iAUFGABE_5 'Deinstallation durchfhren und in gsAktion beschreiben
'
'        If gbDeinstalltionAktivFlag = True Then
'            'Diese Aufgabe wird nur bei der Deinstallation ausgefhrt
'            For iZaehler = LBound(gsDefaultPDFBetrachterTabelle, 1) To UBound(gsDefaultPDFBetrachterTabelle, 1)
'                If LCase(gsDefaultPDFBetrachterTabelle(iZaehler, 6)) = True _
'                And LCase(gsDefaultPDFBetrachterTabelle(iZaehler, 4)) = True Then
'                    If IsNull(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, "SOFTWARE\Ghostgum\GSview", _
'                        gsDefaultPDFBetrachterTabelle(iZaehler, 3), WITH_RETURN_NULL)) = False Then
'                        If fbRegistry_WertLoeschen(HKEY_LOCAL_MACHINE, "SOFTWARE\Ghostgum\GSview", gsDefaultPDFBetrachterTabelle(iZaehler, 3)) = True Then
'                            gsAktion = gsAktion & sPREFIX & fsText(sTXT_GHOSTVIEWWURDEDEREGISTRIERT _
'                                    , gsDefaultPDFBetrachterTabelle(iZaehler, 0)) & vbCr
'                        Else
'                            'Fehler: Ghostview konnte nicht aus der Registry gelscht werden
'                            sText = fsText(sMSG_KONNTEGHOSTVIEWNICHTDEREGISTRIEREN, gsDefaultPDFBetrachterTabelle(iZaehler, 0))
'                            gsAktion = gsAktion & sPREFIX & sText & vbCr
'                            MsgBox sText, vbExclamation, sTITEL_DEINSTALLIEREN
'                            Exit Function
'                        End If
'                    End If
'                End If
'            Next iZaehler
'        End If
'
    Case iAUFGABE_6 'Wenn gbWordFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
    Case iAUFGABE_7 'Wenn ein PDF-Betrachterinstalliert werden soll Installation durchfhren und in gsAktion beschreiben
        
        iZaehler = fiPDFBetrachterDefaultNr_ermitteln(gsPDFProgrammName, 1)
        If gsDefaultPDFBetrachterTabelle(iZaehler, 5) <> sLEER Then
            'Aktion durchfhren
            sText = fsGhostview_entpacken(gsPDFProgrammName, gsGSProgrammName)
            If sText = sLEER Then
                gsAktion = gsAktion & sPREFIX & fsText(sTXT_PDFBETRACHTERWURDEENTPACKT _
                    , gsDefaultPDFBetrachterTabelle(iZaehler, 0)) & vbCr
            Else
                'Fehler: Add-In konnte nicht entpackt werden
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
            
    End Select
    
    fbPDFBetrachter_installieren = True

End Function

Function fbWord_installieren(iAufgabe As Integer, sOfficeVersion As String, bAktion As Byte) As Boolean
    'Die Funktion installiert in drei Aufrufen gsWordAddIn im Startup-Verzeichniss von Word.
    'Zuvor werden alle alten Versionen des Add-In gelscht.
    'Die Funktion verwendet folgende Einstellungen:
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\WORD\OPTIONS\, STARTUP-PATH
    'Argumente:
    '   iAufgabe siehe Deklaration iAUFGABE_n
    '   sOfficeVersion ist die Versionsnummer von Office
    '   bAktion = Aktion beim Erzeugen des Add-In
    '       bERZEUGE_AUS_RUNTIME oder bERZEUGE_AUS_RUNTIME_MIT_TRACE
    'Global:
    '   gsWordAddIn wird gelesen (Name des Word-Add-In)
    '   gsAlteWordAddIns wird gelesen
    '   gsInsVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    '   gbDebugFlag wird gelesen
    '   gbWordFlag wird gelesen und gendert
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim bErgebnis As Boolean
    Dim sDir(3) As String
    Dim vEinDir As Variant
    Dim iZaehler1 As Integer
    Dim iZaehler2 As Integer
    Dim sDatei As String
    Dim lPosition As Long
    Dim sRegOfficePath As String
    Dim sRegOptionsPath As String
    Dim sRegInstallrootPath As String
    Dim sRegSecurityPath As String
    Dim vEinAddIn As Variant
    Dim sText As String
    Const sPREFIX As String = "    Word: "
         
    fbWord_installieren = False
        
    sRegOfficePath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD"
    sRegOptionsPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD\OPTIONS"
    sRegInstallrootPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD\INSTALLROOT"
    sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD\SECURITY"
            
    'Startup-Dir fr Word ermitteln
    'Die Reihenfolge, in der die Tabelle sDir() gefllt wird, beeinflusst, in welches Verzeichnis
    'das Add-In bei der Installation kopiert wird
           
    ' 1. Autostart-Verzeichnis des Users
    iZaehler1 = 0
    sDir(iZaehler1) = Word.Application.Options.DefaultFilePath(wdStartupPath)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    
    ' 2. Autostart-Verzeichnis aus der Registry
    'Fehlt unter Office 10.0, wenn es das Default-Verzeichnis ist
    iZaehler1 = 1
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegOptionsPath, "STARTUP-PATH", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    
    '3. Autostart-Verzeichnis der Installation
    iZaehler1 = 2
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegOptionsPath, "PROGRAMDIR", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    If sDir(iZaehler1) <> sLEER Then
        sDir(iZaehler1) = sDir(iZaehler1) & "startup\"
    End If
            
    '4. Noch einmal Autostart-Verzeichnis der Installation
    'Das Ergebnis in sDir(1) und sDir(2) msste immer gleich sein, aber mir kann niemand
    'besttigen, dass diese beiden Registry-Eintrge immer redundant vorhanden sind.
    iZaehler1 = 3
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    If sDir(iZaehler1) <> sLEER Then
        sDir(iZaehler1) = sDir(iZaehler1) & "startup\"
    End If
    
    'Doubletten in sDir() entfernen
    For iZaehler1 = LBound(sDir) To UBound(sDir)
        For iZaehler2 = iZaehler1 + 1 To UBound(sDir)
            If LCase(sDir(iZaehler1)) = LCase(sDir(iZaehler2)) Then
                sDir(iZaehler2) = sLEER
            End If
        Next iZaehler2
    Next iZaehler1
    
    'Word darf nur zweimal laufen (einmal (Auto)setup.dot und einmal installation.dot)
    If iAufgabe > iAUFGABE_1 Then
        If fiAnzahlInstanzen_ermitteln(sTASKNAME_WORD) > 2 _
        And gbAnzahlWordInstanzenOKFlag = False Then
            'Fehler: Mehrere Word-Instanzen
            sText = fsText(sMSG_LAEUFTWORDMEHRFACH1)
            If MsgBox(sText _
                , vbYesNo + vbExclamation, sTITEL_INSTALLIEREN) <> vbNo Then
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                sText = fsText(sMSG_LAEUFTWORDMEHRFACH2) 'Abgebrochen
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                Exit Function
            End If
            Call fbWarten(2)
            If fiAnzahlInstanzen_ermitteln(sTASKNAME_WORD) > 2 Then
                'Fehler: Mehrere Word-Instanzen vorhanden auch nachdem eine Meldebox angezeigt und etwas Zeit vergangen ist
                sText = fsText(sMSG_LAEUFTWORDMEHRFACH3)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                gbAnzahlWordInstanzenOKFlag = True
            Else
                'Nur noch ein oder zwei Word-Instanzen vorhanden nachdem eine Meldebox angezeigt und etwas Zeit vergangen ist
                sText = fsText(sMSG_LAEUFTWORDMEHRFACH4)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
            End If
        End If
    End If
    
    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case iAUFGABE_0 'gbWordFlag und Sicherheitsflag setzen und in gsAktion beschreiben
        If fsDir_ermitteln(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)) = sLEER Then
            gbWordFlag = False
        Else
            gbWordFlag = True
        End If
        ' If fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sRegSecurityPath) = True Then
        If gbWordFlag = False _
        Or sOfficeVersion = "8.0" _
        Or fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, sSECURITYNAME_DONTTRUST, _
        NEVER_RETURN_NULL) = vSECURITYWERT_DONTTRUST Then
            gbWordSicherheit = True
        Else
            gbWordSicherheit = False
        End If
    Case iAUFGABE_1 'Schalter zum Erzeugen der Add-Ins setzen
        If Dir(gsInstVerzeichnis & sKONFIGURATIONS_ADDIN, vbNormal) = sLEER Then
            'Ein Programm  soll verwendet werden aber das Add-in fehlt.
            gbKonfAddInErzeugenFlag = True
            gbKonfAddInErzeugenAenderbar = False
        Else
            'Ein Programm soll verwendet werden und das Add-In ist schon vorhanden.
            gbWordAddInErzeugenFlag = gbDebugFlag
            gbKonfAddInErzeugenAenderbar = gbEinRechnerInstallation
        End If
        'Das Word-Add-In wird nicht unbeding bentigt
        If gbWordFlag = True Then
            If Dir(gsInstVerzeichnis & gsWordAddIn, vbNormal) = sLEER Then
                'Word soll verwendet werden aber das Add-in fehlt.
                gbWordAddInErzeugenFlag = True
                gbWordAddInErzeugenAenderbar = False
            Else
                'Word soll verwendet werden und das Add-In ist schon vorhanden.
                gbKonfAddInErzeugenFlag = gbDebugFlag
                gbWordAddInErzeugenAenderbar = gbEinRechnerInstallation
            End If
        Else
            'Word soll nicht verwendet werden.
            gbWordAddInErzeugenFlag = False
            gbWordAddInErzeugenAenderbar = False
        End If
    Case iAUFGABE_2 'Deinstallation in gsAktion beschreiben
        For Each vEinDir In sDir
            If vEinDir <> sLEER Then
                sDatei = Dir(vEinDir & gsAlteWordAddIns, vbNormal)
                Do While sDatei <> ""
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_DARFADDINNICHTLOESCHEN, sDatei, CStr(vEinDir)) & vbCr
                    Else
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_LOESCHEADDIN, sDatei, CStr(vEinDir)) & vbCr
                    End If
                    sDatei = Dir ' Nchsten Eintrag abrufen.
                Loop
            End If
        Next vEinDir
        'Konfiguration lschen beschreiben
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_WORD)) Then
            gsAktion = gsAktion & sPREFIX _
                & sTXT_LOESCHEREGISTRY & vbCr
        End If
    Case iAUFGABE_3 'Wenn ein gbXXXFlag gesetzt ist Erzeugen der Konfigurations-Add-Ins in gsAktion
        'beschreiben. Wenn gbWordFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
        'Das Konfigurations-Add-In wird immer bentigt
        If gbKonfAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & sKONFIGURATIONS_ADDIN, vbNormal) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEADDIN, sKONFIGURATIONS_ADDIN, gsInstVerzeichnis) & vbCr
            End If
            gsAktion = gsAktion & sPREFIX _
                & fsText(sTXT_ERZEUGEADDIN, sKONFIGURATIONS_ADDIN, gsInstVerzeichnis) & vbCr
        End If
        If gbWordAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsWordAddIn, vbNormal) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEADDIN, gsWordAddIn, gsInstVerzeichnis) & vbCr
            End If
            gsAktion = gsAktion & sPREFIX _
                & fsText(sTXT_ERZEUGEADDIN, gsWordAddIn, gsInstVerzeichnis) & vbCr
        End If
    Case iAUFGABE_4 'Wenn gbWordFlag gesetzt ist Installation, nderung der Sicherheitseinstellungen und
        'erstellen der Konfiguration in gsAktion beschreiben
        If gbWordFlag = True Then
            'Installation beschreiben
            For Each vEinDir In sDir
                If vEinDir <> sLEER Then
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_MUSSADDINNICHTKOPIEREN, sDatei, CStr(vEinDir)) & vbCr
                    Else
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_KOPIEREADDIN, gsWordAddIn, CStr(vEinDir)) & vbCr
                    End If
                    Exit For
                End If
            Next vEinDir
            'Konfiguration anlegen beschreiben
            gsAktion = gsAktion & sPREFIX _
                & sTXT_SCHREIBEREGISTRY & vbCr
            'Sicherheitseinstellungen beschreiben
            If gbWordSicherheit = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_SICHERHEITUNVERAENDERTLASSEN & vbCr
            Else
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_SICHERHEITANPASSEN, sRegSecurityPath) & vbCr
            End If
        End If
    Case iAUFGABE_5 'Deinstallation durchfhren und in gsAktion beschreiben
        'Alle alten Versionen des Add-In lschen
        For Each vEinDir In sDir
            If vEinDir <> sLEER Then
                sDatei = Dir(vEinDir & gsAlteWordAddIns, vbNormal)
                Do While sDatei <> ""
                    For Each vEinAddIn In AddIns
                        If vEinAddIn.Installed = True Then
                            If LCase(vEinAddIn.Name) = LCase(sDatei) Then
                                vEinAddIn.Installed = False
                            End If
                        End If
                    Next vEinAddIn
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ADDINWURDENICHTGELOESCHT, sDatei, CStr(vEinDir)) & vbCr
                    ElseIf fbDatei_loeschen(vEinDir & sDatei) = True Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ADDINWURDEGELOESCHT, sDatei, CStr(vEinDir)) & vbCr
                    Else
                        'Fehler: Add-In konnte nicht gelscht werden
                        sText = fsText(sMSG_KONNTEADDINNICHTLOESCHEN _
                            , sDatei _
                            , CStr(vEinDir))
                        gsAktion = gsAktion & sPREFIX & sText & vbCr
                        MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                        Exit Function
                    End If
                    sDatei = Dir(vEinDir & gsAlteWordAddIns, vbNormal)
                    'sDatei = Dir 'reicht hier nicht, denn in fbDatei_loeschen wurde Dir verndert
                Loop
            End If
        Next vEinDir
        'Konfiguration lschen
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_WORD)) Then
            If fbKonfiguration_loeschen(sTASKNAME_WORD) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_REGISTRYWURDEGELOESCHT & vbCr
            Else
                'Fehler: Add-In konnte nicht gelscht werden
                sText = fsText(sMSG_KONNTEREGITRYNICHTLOESCHEN)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case iAUFGABE_6 'Wenn gbWordFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
        If gbKonfAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & sKONFIGURATIONS_ADDIN, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & sKONFIGURATIONS_ADDIN) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_ADDINWURDEGELOESCHT, sKONFIGURATIONS_ADDIN, gsInstVerzeichnis) & vbCr
                Else
                    'Fehler: Add-In konnte nicht gelscht werden
                    sText = fsText(sMSG_KONNTEADDINNICHTLOESCHEN _
                        , sKONFIGURATIONS_ADDIN _
                        , gsInstVerzeichnis)
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbKonfigurationAddInErzeugen(sOfficeVersion, bAktion) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_ADDINWURDEERZEUGT, sKONFIGURATIONS_ADDIN, gsInstVerzeichnis) & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & sKONFIGURATIONS_ADDIN)
               'Fehler: Add-In konnte nicht erzeugt werden
                sText = fsText(sMSG_KONNTEADDINNICHTERZEUGEN _
                    , sKONFIGURATIONS_ADDIN _
                    , gsInstVerzeichnis)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
        If gbWordAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsWordAddIn, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & gsWordAddIn) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_ADDINWURDEGELOESCHT, gsWordAddIn, gsInstVerzeichnis) & vbCr
                Else
                    'Fehler: Add-In konnte nicht gelscht werden
                    sText = fsText(sMSG_KONNTEADDINNICHTLOESCHEN _
                        , gsWordAddIn _
                        , gsInstVerzeichnis)
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbWordAddInErzeugen(sOfficeVersion, bAktion) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_ADDINWURDEERZEUGT, gsWordAddIn, gsInstVerzeichnis) & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & gsWordAddIn)
                'Fehler: Add-In konnte nicht erzeugt werden
                sText = fsText(sMSG_KONNTEADDINNICHTERZEUGEN _
                    , gsWordAddIn _
                    , gsInstVerzeichnis)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case iAUFGABE_7 'Wenn gbWordFlag gesetzt ist Installation durchfhren und in gsAktion beschreiben
        If gbWordFlag = True Then
            'Installation durchfhren
            For Each vEinDir In sDir
                If vEinDir <> sLEER Then
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ADDINWURDENICHTKOPIERT, sDatei, CStr(vEinDir)) & vbCr
                    ElseIf fbDatei_kopieren(gsInstVerzeichnis & gsWordAddIn, _
                        vEinDir & gsWordAddIn) = True Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ADDINWURDEKOPIERT, gsWordAddIn, gsInstVerzeichnis, _
                            CStr(vEinDir)) & vbCr
                        Exit For
                    Else
                        'Fehler: Add-In konnte nicht kopiert werden
                        sText = fsText(sMSG_KONNTEADDINNICHTKOPIEREN _
                            , gsWordAddIn _
                            , gsInstVerzeichnis _
                            , CStr(vEinDir))
                        gsAktion = gsAktion & sPREFIX & sText & vbCr
                        MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                        Exit Function
                    End If
                End If
            Next vEinDir
            'Konfiguration anlegen
            Call fbKonfiguration_mitAnwendungsDefaultsBelegen(sTASKNAME_WORD, True)
            gsMailToSwitch = gsInstallationsMailToSwitch
            If fbKonfiguration_schreiben(sTASKNAME_WORD) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_REGISTRYWURDEGESCHRIEBEN & vbCr
            Else
                'Fehler: Konfiguration konnte nicht in die Registry geschrieben werden
                sText = fsText(sMSG_KONNTEREGITRYNICHTSCHREIBEN)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
            'Sicherheitseinstellungen aendern
            If gbWordSicherheit = False Then
                If fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST, vSECURITYWERT_DONTTRUST, REG_DWORD) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_SICHERHEITWURDEGEAENDERT, sRegSecurityPath) & vbCr
                Else
                    'Fehler: Sicherheitseinstellungen konnten nicht verndert werden
                    sText = fsText(sMSG_KONNTESICHERHEITNICHTAENDERN _
                        , sRegSecurityPath)
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                 End If
            End If
        End If
    End Select
    
    fbWord_installieren = True

End Function

Function fbExcel_installieren(iAufgabe As Integer, sOfficeVersion As String, bAktion As Byte) As Boolean
    'Die Funktion installiert in drei Aufrufen gsExcelAddIn im Xlstart-Verzeichniss von Excel.
    'Zuvor werden alle alten Versionen des Add-In gelscht.
    'Die Funktion verwendet folgende Einstellungen:
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\EXCEL\INSTALLROOT\, PATH
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\EXCEL\MICROSOFT EXCEL\, ALTSTARTUP
    'Argumente:
    '   iAufgabe siehe Deklaration iAUFGABE_n
    '   sOfficeVersion ist die Versionsnummer von Office
    '   bAktion = Aktion beim Erzeugen des Add-In
    '       bERZEUGE_AUS_RUNTIME oder bERZEUGE_AUS_RUNTIME_MIT_TRACE
    'Global:
    '   gsExcelAddIn wird gelesen (Name des Excel-Add-In)
    '   gsAlteExcelAddIns wird gelesen
    '   gsInsVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    '   gbDebugFlag wird gelesen
    '   gbExcelxxFlag wird gelesen und gendert
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim oExcel As Object 'Zum Test ob Excel existiert
    Dim bErgebnis As Boolean
    Dim sDir(3) As String
    Dim vEinDir As Variant
    Dim iZaehler1 As Integer
    Dim iZaehler2 As Integer
    Dim sAddIn() As String
    Dim sOpenName() As String
    Dim sOpenWert() As String
    Dim lIndex As Long
    Dim iZaehler As Integer
    Dim sDatei As String
    Dim lPosition As Long
    Dim sRegOfficePath As String
    Dim sRegOptionsPath As String
    Dim sRegAddInManagerPath As String
    Dim sRegMicrosoftExcelPath As String
    Dim sRegInstallrootPath As String
    Dim sRegSecurityPath As String
    Dim sWert As String
    Dim vWertName As Variant
    Dim sWertName As String
    Dim sPfade(1) As String
    Dim vEinPfad As Variant
    Dim sEinPfad As String
    Dim sText As String
    Const sPREFIX As String = "    Excel: "

    fbExcel_installieren = False
           
    sRegOptionsPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\OPTIONS"
    sRegAddInManagerPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\Add-IN MANAGER"
    sRegMicrosoftExcelPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\MICROSOFT EXCEL"
    sRegInstallrootPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\INSTALLROOT"
    sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\SECURITY"
                  
    'Prfen on Gs4Word im Excel-Men "Extras > Add-In-Manager..." als Add-In eingetragen ist
    'Je nach Office-Version steht der Schssel OPEN, OPENn oder OPENnn (mit n und nn als Zahl)
    'in Office\x.x\Excel\Options\ oder Office\x.x\Excel\Microsoft Excel\
     
    'Eintrge in Excel\Options und Excel\Microsoft Excel durchsuchen
    sPfade(0) = sRegOptionsPath ' In Office 10.0 und ?
    sPfade(1) = sRegMicrosoftExcelPath 'In Office 8.0 und ?
    ReDim sOpenName(0)
    ReDim sOpenWert(0)
    For Each vEinPfad In sPfade
        sEinPfad = CStr(vEinPfad)
        lIndex = 0
        Do While True
            vWertName = fvRegistry_WertNummerLesen(HKEY_CURRENT_USER, sEinPfad, lIndex)
            If IsNull(vWertName) = True Then 'fertig
                Exit Do
            End If
            sWertName = CStr(vWertName)
            If UCase(Left(sWertName, 4)) = "OPEN" _
            And (Len(sWertName) = 4 _
            Or (Len(sWertName) > 4 And IsNumeric(Mid(sWertName, 5)) = True)) Then
                sWert = fvRegistry_WertLesen(HKEY_CURRENT_USER, sEinPfad, sWertName, NEVER_RETURN_NULL)
                If InStr(1, sWert, sADDIN_NAME, 1) > 0 Then
                    sOpenName(UBound(sOpenName)) = sWertName
                    sOpenWert(UBound(sOpenWert)) = sWert
                    ReDim Preserve sOpenName(UBound(sOpenName) + 1)
                    ReDim Preserve sOpenWert(UBound(sOpenWert) + 1)
                End If
            End If
            lIndex = lIndex + 1
        Loop
    Next vEinPfad
    
    'Eintrge in Excel\Add-In Manager durchsuchen
    sEinPfad = sRegAddInManagerPath
    lIndex = 0
    ReDim sAddIn(0)
    Do While True
        vWertName = fvRegistry_WertNummerLesen(HKEY_CURRENT_USER, sEinPfad, lIndex)
        If IsNull(vWertName) = True Then 'fertig
            Exit Do
        End If
        sWertName = CStr(vWertName)
        If InStr(1, sWertName, sADDIN_NAME, 1) > 0 Then
            sAddIn(UBound(sAddIn)) = sWertName
            ReDim Preserve sAddIn(UBound(sAddIn) + 1)
        End If
        lIndex = lIndex + 1
    Loop
     
    'Xlstart-Dir fr Excel ermitteln
    'Die Reihenfolge, in der die Tabelle sDir() gefllt wird, beeinflusst, in welches Verzeichnis
    'das Add-In bei der Installation kopiert wird
    
    '1. Autostart-Verzeichnis des Users ab Office 9.0
    iZaehler1 = 0
    If gbExcelFlag = True Then
        sDir(iZaehler1) = Gib_ExcelStartupVerzeichnis & "\"
    End If
    
    '2. Autostart-Verzeichnis der Installation
    iZaehler1 = 1
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    If sDir(iZaehler1) <> sLEER Then
        sDir(iZaehler1) = sDir(iZaehler1) & "xlstart\"
    End If
    
    '3. Alternatives Autostart-Verzeichnis (das gibt es nur in Excel)
    iZaehler1 = 2
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegMicrosoftExcelPath, "ALTSTARTUP", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
     
    '4. Alternatives Autostart-Verzeichnis (das gibt es nur in Excel)
    'Je nach Office-Version steht der Schssel ALTSTARTUP
    'in Office\x.x\Excel\Options\ oder Office\x.x\Excel\Microsoft Excel\
    iZaehler1 = 3
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegMicrosoftExcelPath, "ALTSTARTUP", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    
    'Doubletten in sDir() entfernen
    For iZaehler1 = LBound(sDir) To UBound(sDir)
        For iZaehler2 = iZaehler1 + 1 To UBound(sDir)
            If LCase(sDir(iZaehler1)) = LCase(sDir(iZaehler2)) Then
                sDir(iZaehler2) = sLEER
            End If
        Next iZaehler2
    Next iZaehler1
    
    'Excel darf nicht laufen
    If iAufgabe > iAUFGABE_1 Then
        If fiAnzahlInstanzen_ermitteln(sTASKNAME_EXCEL) > 0 Then
            'Fehler: Mehrere Excel-Instanzen
            sText = fsText(sMSG_EXCELLAEUFT)
            gsAktion = gsAktion & sPREFIX & sText & vbCr
            MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
            Exit Function
        End If
    End If
        
    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case iAUFGABE_0 'gbExcelFlag und Sicherheitsflag setzen und in gsAktion beschreiben
        If fsDir_ermitteln(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)) = sLEER Then
            gbExcelFlag = False
        Else
            'Excel auf Echtheit prfen
            On Error Resume Next ' wenn der folgende Befehl misslingt, ist oExcel Nothing
            Set oExcel = CreateObject("Excel.Application") 'Erzeugt einen neue Instanz von Excel
            On Error GoTo 0
            If oExcel Is Nothing Then
                gbExcelFlag = False
            Else
                oExcel.Quit
                Set oExcel = Nothing
                gbExcelFlag = True
                'Hier gibt es unter verschiedenen Kombinationen von Windows und Excel einen Fehler:
                'Das Objekt wird nicht immer richtig aus dem Speicher entfernt.
                'Der Fehler ist unter Windows 2000 / Office 2000 und Windows 98 / Office 2002
                'reproduzierbar .
                'Er tritt in der Kombination Windows NT / Office 2000 nicht auf.
                'Siehe fiAnzahlInstanzen_ermitteln
            End If
        End If
        ' If fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sRegSecurityPath) = True Then
        If gbExcelFlag = False _
        Or sOfficeVersion = "8.0" _
        Or fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, sSECURITYNAME_DONTTRUST, _
        NEVER_RETURN_NULL) = vSECURITYWERT_DONTTRUST Then
            gbExcelSicherheit = True
        Else
            gbExcelSicherheit = False
        End If
    Case iAUFGABE_1 'Schalter zum Erzeugen der Add-Ins setzen
        If gbExcelFlag = True Then
            If Dir(gsInstVerzeichnis & gsExcelAddIn, vbNormal) = sLEER Then
                'Excel soll verwendet werden aber das Add-in fehlt.
                gbExcelAddInErzeugenFlag = True
                gbExcelAddInErzeugenAenderbar = False
            Else
                'Excel soll verwendet werden und das Add-In ist schon vorhanden.
                gbExcelAddInErzeugenFlag = gbDebugFlag
                gbExcelAddInErzeugenAenderbar = gbEinRechnerInstallation
            End If
        Else
            'Excel kann oder soll nicht verwendet werden.
            gbExcelAddInErzeugenFlag = False
            gbExcelAddInErzeugenAenderbar = False
        End If
    Case iAUFGABE_2 'Deinstallation in gsAktion beschreiben
        For iZaehler = LBound(sOpenWert) To UBound(sOpenWert)
            If sOpenWert(iZaehler) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEKEYMITWERT, sRegMicrosoftExcelPath, sOpenName(iZaehler), _
                    sOpenWert(iZaehler)) & vbCr
            End If
        Next iZaehler
        For iZaehler = LBound(sAddIn) To UBound(sAddIn)
            If sAddIn(iZaehler) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEKEY, sRegAddInManagerPath, sAddIn(iZaehler)) & vbCr
            End If
        Next iZaehler
        
        For Each vEinDir In sDir
            If vEinDir <> sLEER Then
                sDatei = Dir(vEinDir & gsAlteExcelAddIns, vbNormal)
                Do While sDatei <> ""
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_DARFADDINNICHTLOESCHEN, sDatei, CStr(vEinDir)) & vbCr
                    Else
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ENTFERNESCHREIBSCHUTZ, sDatei, CStr(vEinDir)) & vbCr
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_LOESCHEADDIN, sDatei, CStr(vEinDir)) & vbCr
                    End If
                    sDatei = Dir ' Nchsten Eintrag abrufen.
                Loop
            End If
        Next vEinDir
        'Konfiguration lschen beschreiben
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_EXCEL)) Then
            gsAktion = gsAktion & sPREFIX _
                & sTXT_LOESCHEREGISTRY & vbCr
        End If
    Case iAUFGABE_3 'Wenn gsExcelFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
        If gbExcelAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsExcelAddIn, vbNormal) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEADDIN, gsExcelAddIn, gsInstVerzeichnis) & vbCr
            End If
            gsAktion = gsAktion & sPREFIX _
                & fsText(sTXT_ERZEUGEADDIN, gsExcelAddIn, gsInstVerzeichnis) & vbCr
        End If
    Case iAUFGABE_4 'Wenn gsExcelFlag gesetzt ist Installation, nderung der Sicherheitseinstellungen und
        'erstellen der Konfiguration in gsAktion beschreiben
        If gbExcelFlag = True Then
           'Installation beschreiben
           For Each vEinDir In sDir
               If vEinDir <> sLEER Then
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_MUSSADDINNICHTKOPIEREN, gsExcelAddIn, CStr(vEinDir)) & vbCr
                    Else
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_KOPIEREADDIN, gsExcelAddIn, CStr(vEinDir)) & vbCr
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_SETZESCHREIBSCHUTZ, gsExcelAddIn, CStr(vEinDir)) & vbCr
                    End If
                    Exit For
                End If
            Next vEinDir
            'Konfiguration anlegen beschreiben
            gsAktion = gsAktion & sPREFIX _
                & sTXT_SCHREIBEREGISTRY & vbCr
            'Sicherheitseinstellungen beschreiben
            If gbExcelSicherheit = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_SICHERHEITUNVERAENDERTLASSEN & vbCr
            Else
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_SICHERHEITANPASSEN, sRegSecurityPath) & vbCr
            End If
        End If
    Case iAUFGABE_5 'Deinstallation durchfhren und in gsAktion beschreiben
        'Alle alten Eintrge zum Add-In in der Registry lschen
        For iZaehler = LBound(sOpenWert) To UBound(sOpenWert)
            If sOpenWert(iZaehler) <> sLEER Then
                bErgebnis = fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegMicrosoftExcelPath, _
                    sOpenName(iZaehler))
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_KEYMITWERTWURDEGELOESCHT, sRegMicrosoftExcelPath, _
                    sOpenName(iZaehler), sOpenWert(iZaehler)) & vbCr
            End If
        Next iZaehler
        For iZaehler = LBound(sAddIn) To UBound(sAddIn)
            If sAddIn(iZaehler) <> sLEER Then
                bErgebnis = fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegAddInManagerPath, _
                    sAddIn(iZaehler))
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_KEYWURDEGELOESCHT, sRegAddInManagerPath, _
                    sAddIn(iZaehler)) & vbCr
            End If
        Next iZaehler
        
        'Alle alten Versionen des Add-In lschen
        For Each vEinDir In sDir
            If vEinDir <> sLEER Then
                sDatei = Dir(vEinDir & gsAlteExcelAddIns, vbNormal)
                Do While sDatei <> ""
                    SetAttr vEinDir & sDatei, vbNormal 'Bei Excel Schreibschutz entfernen
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_SCHREIBSCHUTZWURDEENTFERNT, sDatei, CStr(vEinDir)) & vbCr
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ADDINWURDENICHTGELOESCHT, sDatei, CStr(vEinDir)) & vbCr
                    ElseIf fbDatei_loeschen(vEinDir & sDatei) = True Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ADDINWURDEGELOESCHT, sDatei, CStr(vEinDir)) & vbCr
                    Else
                        'Fehler: Add-In konnte nicht gelscht werden
                        sText = fsText(sMSG_KONNTEADDINNICHTLOESCHEN _
                            , sDatei _
                            , CStr(vEinDir))
                        gsAktion = gsAktion & sPREFIX & sText & vbCr
                        MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                        Exit Function
                    End If
                    sDatei = Dir(vEinDir & gsAlteExcelAddIns, vbNormal)
                    'sDatei = Dir 'reicht hier nicht, denn in fbDatei_loeschen wurde Dir verndert
                Loop
            End If
        Next vEinDir
        'Konfiguration lschen
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_EXCEL)) Then
            If fbKonfiguration_loeschen(sTASKNAME_EXCEL) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_REGISTRYWURDEGELOESCHT & vbCr
            Else
                'Fehler: Add-In konnte nicht gelscht werden
                sText = fsText(sMSG_KONNTEREGITRYNICHTLOESCHEN)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case iAUFGABE_6 'Wenn gsExcelFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
        If gbExcelAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsExcelAddIn, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & gsExcelAddIn) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_ADDINWURDEGELOESCHT, gsExcelAddIn, gsInstVerzeichnis) & vbCr
                Else
                    'Fehler: Add-In konnte nicht gelscht werden
                    sText = fsText(sMSG_KONNTEADDINNICHTLOESCHEN _
                        , gsExcelAddIn _
                        , gsInstVerzeichnis)
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbExcelAddInErzeugen(sOfficeVersion, bAktion) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_ADDINWURDEERZEUGT, gsExcelAddIn, gsInstVerzeichnis) & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & gsExcelAddIn)
                'Fehler: Add-In konnte nicht erzeugt werden
                sText = fsText(sMSG_KONNTEADDINNICHTERZEUGEN _
                    , gsExcelAddIn _
                    , gsInstVerzeichnis)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case iAUFGABE_7 'Wenn gsExcelFlag gesetzt ist Installation durchfhren und in gsAktion beschreiben
        If gbExcelFlag = True Then
            'Installation durchfhren
            For Each vEinDir In sDir
                If vEinDir <> sLEER Then
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ADDINWURDENICHTKOPIERT, sDatei, CStr(vEinDir)) & vbCr
                        Exit For
                    ElseIf fbDatei_kopieren(gsInstVerzeichnis & gsExcelAddIn, _
                        vEinDir & gsExcelAddIn) = True Then
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_ADDINWURDEKOPIERT, gsExcelAddIn, gsInstVerzeichnis, _
                            CStr(vEinDir)) & vbCr
                        SetAttr vEinDir & gsExcelAddIn, vbReadOnly 'Bei Excel Schreibschutz setzen
                        gsAktion = gsAktion & sPREFIX _
                            & fsText(sTXT_SCHREIBSCHUTZWURDEGESETZT, gsExcelAddIn, CStr(vEinDir)) _
                            & vbCr
                        Exit For
                    Else
                        'Fehler: Add-In konnte nicht kopiert werden
                        sText = fsText(sMSG_KONNTEADDINNICHTKOPIEREN _
                            , gsExcelAddIn _
                            , gsInstVerzeichnis _
                            , CStr(vEinDir))
                        gsAktion = gsAktion & sPREFIX & sText & vbCr
                        MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                        Exit Function
                    End If
                End If
            Next vEinDir
            'Konfiguration anlegen
            Call fbKonfiguration_mitAnwendungsDefaultsBelegen(sTASKNAME_EXCEL, True)
            gsMailToSwitch = gsInstallationsMailToSwitch
            If fbKonfiguration_schreiben(sTASKNAME_EXCEL) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_REGISTRYWURDEGESCHRIEBEN & vbCr
            Else
                'Fehler: Konfiguration konnte nicht in die Registry geschrieben werden
                sText = fsText(sMSG_KONNTEREGITRYNICHTSCHREIBEN)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
            'Sicherheitseinstellungen aendern
            If gbExcelSicherheit = False Then
                If fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST, vSECURITYWERT_DONTTRUST, REG_DWORD) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_SICHERHEITWURDEGEAENDERT, sRegSecurityPath) & vbCr
                Else
                    'Fehler: Sicherheitseinstellungen konnten nicht verndert werden
                    sText = fsText(sMSG_KONNTESICHERHEITNICHTAENDERN _
                        , sRegSecurityPath)
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                 End If
            End If
        End If
    End Select
    
    fbExcel_installieren = True

End Function

Function fbPowerpoint_installieren(iAufgabe As Integer, sOfficeVersion As String, bAktion As Byte) As Boolean
    'Die Funktion installiert in drei Aufrufen gsPowerpointAddIn fr Powerpoint in
    'HKEY_CURRENT_USER.
    'Zuvor werden alle alten Versionen des Add-In in HKEY_CURRENT_USER und HKEY_LOCAL_MACHINE
    'gelscht.
    'Die Funktion verwendet folgende Einstellungen:
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\, ""
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, ""
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, AUTOLOAD
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, PATH
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\, ""
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, ""
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, AUTOLOAD
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, PATH
    'Argumente:
    '   iAufgabe siehe Deklaration iAUFGABE_n
    '   sOfficeVersion ist die Versionsnummer von Office
    '   bAktion = Aktion beim Erzeugen des Add-In
    '       bERZEUGE_AUS_RUNTIME oder bERZEUGE_AUS_RUNTIME_MIT_TRACE
    'Global:
    '   gsPowerpointAddInRegistryName wird gelesen (Name des Add-In)
    '   gsAltePowerpointAddIns wird gelesen
    '   gsInsVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    '   gbDebugFlag wird gelesen
    '   gbPowerpointxxFlag wird gelesen und gendert
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim oPowerpoint As Object 'Zum Test ob Powerpoint existiert
    Dim bErgebnis As Boolean
    Dim sCurrentUserAddIns() As String
    Dim sLocalMachineAddIns() As String
    Dim iZaehler As Integer
    Dim sRegAddInsPath As String
    Dim sRegInstallrootPath As String
    Dim sRegSecurityPath As String
    Dim lIndex As Long
    Dim vWertName As Variant
    Dim sWertName As String
    Dim sText As String
    Const sPREFIX As String = "    Powerpoint: "
         
    fbPowerpoint_installieren = False
        
    sRegAddInsPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\POWERPOINT\ADDINS"
    sRegInstallrootPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\POWERPOINT\INSTALLROOT"
    sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\POWERPOINT\SECURITY"
                            
    'Prfen ob Gs4Word im Powerpoint-Men "Extras>Add-In-Manager..." als Add-In eingetragen ist
    lIndex = 0
    ReDim sCurrentUserAddIns(0)
    Do While True
        vWertName = fvRegistry_SubPfadNummerLesen(HKEY_CURRENT_USER, sRegAddInsPath, lIndex)
        If IsNull(vWertName) = True Then 'fertig
            Exit Do
        End If
        sWertName = CStr(vWertName)
        If InStr(1, sWertName, sADDIN_NAME, 1) > 0 Then
            sCurrentUserAddIns(UBound(sCurrentUserAddIns)) = sWertName
            ReDim Preserve sCurrentUserAddIns(UBound(sCurrentUserAddIns) + 1)
        End If
        lIndex = lIndex + 1
    Loop
    lIndex = 0
    ReDim sLocalMachineAddIns(0)
    Do While True
        vWertName = fvRegistry_SubPfadNummerLesen(HKEY_LOCAL_MACHINE, sRegAddInsPath, lIndex)
        If IsNull(vWertName) = True Then 'fertig
            Exit Do
        End If
        sWertName = CStr(vWertName)
        If InStr(1, sWertName, sADDIN_NAME, 1) > 0 Then
            sLocalMachineAddIns(UBound(sLocalMachineAddIns)) = sWertName
            ReDim Preserve sLocalMachineAddIns(UBound(sLocalMachineAddIns) + 1)
        End If
        lIndex = lIndex + 1
    Loop
    
    'Powerpoint darf nicht laufen
    If iAufgabe > iAUFGABE_1 Then
        If fiAnzahlInstanzen_ermitteln(sTASKNAME_POWERPOINT) > 0 Then
            'Fehler: Mehrere Powerpoint-Instanzen
            sText = fsText(sMSG_POWERPOINTLAEUFT)
            gsAktion = gsAktion & sPREFIX & sText & vbCr
            MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
            Exit Function
        End If
    End If
    
    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case iAUFGABE_0 'gbPowerpointFlag und Sicherheitsflag setzen und in gsAktion beschreiben
        If fsDir_ermitteln(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)) = sLEER Then
            gbPowerpointFlag = False
        Else
            gbPowerpointFlag = True
            'Powerpoint auf Echtheit prfen
            On Error Resume Next ' wenn der folgende Befehl misslingt, ist oExcel Nothing
            Set oPowerpoint = CreateObject("Powerpoint.Application") 'Erzeugt einen neue Instanz von Powerpoint
            On Error GoTo 0
            If oPowerpoint Is Nothing Then
                gbPowerpointFlag = False
            Else
                oPowerpoint.Quit
                Set oPowerpoint = Nothing
                gbPowerpointFlag = True
            End If
        End If
        If gbPowerpointFlag = False _
        Or sOfficeVersion = "8.0" _
        Or fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sRegSecurityPath) = False _
        Or fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, sSECURITYNAME_DONTTRUST, _
            NEVER_RETURN_NULL) = vSECURITYWERT_DONTTRUST = True _
        Or IsNull(fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, sSECURITYNAME_DONTTRUST, _
            WITH_RETURN_NULL)) = True Then
            gbPowerpointSicherheit = True
        Else
            gbPowerpointSicherheit = False
        End If
    Case iAUFGABE_1 'Schalter zum Erzeugen der Add-Ins setzen
        If gbPowerpointFlag = True Then
            If Dir(gsInstVerzeichnis & gsPowerpointAddIn, vbNormal) = sLEER Then
                'Powerpoint soll verwendet werden aber das Add-in fehlt.
                gbPowerpointAddInErzeugenFlag = True
                gbPowerpointAddInErzeugenAenderbar = False
            Else
                'Powerpoint soll verwendet werden und das Add-In ist schon vorhanden.
                gbPowerpointAddInErzeugenFlag = gbDebugFlag
                gbPowerpointAddInErzeugenAenderbar = gbEinRechnerInstallation
            End If
        Else
            'Powerpoint kann oder soll nicht verwendet werden.
            gbPowerpointAddInErzeugenFlag = False
            gbPowerpointAddInErzeugenAenderbar = False
        End If
    Case iAUFGABE_2 'Deinstallation in gsAktion beschreiben
        For iZaehler = LBound(sCurrentUserAddIns) To UBound(sCurrentUserAddIns)
            If sCurrentUserAddIns(iZaehler) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEKEYHCUALLEWERTE, sRegAddInsPath, _
                    sCurrentUserAddIns(iZaehler)) & vbCr
            End If
        Next iZaehler
        For iZaehler = LBound(sLocalMachineAddIns) To UBound(sLocalMachineAddIns)
            If sLocalMachineAddIns(iZaehler) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEKEYHLMALLEWERTE, sRegAddInsPath, _
                    sLocalMachineAddIns(iZaehler)) & vbCr
            End If
        Next iZaehler
        'Konfiguration lschen beschreiben
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_POWERPOINT)) Then
            gsAktion = gsAktion & sPREFIX _
                & sTXT_LOESCHEREGISTRY & vbCr
        End If
    Case iAUFGABE_3 'Wenn gbPowerpointFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
        If gbPowerpointAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsPowerpointAddIn, vbNormal) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEADDIN, gsPowerpointAddIn, gsInstVerzeichnis) & vbCr
            End If
            gsAktion = gsAktion & sPREFIX _
                & fsText(sTXT_ERZEUGEADDIN, gsPowerpointAddIn, gsInstVerzeichnis) & vbCr
        End If
    Case iAUFGABE_4 'Wenn gbPowerpointFlag gesetzt ist Installation, nderung der Sicherheitseinstellungen
        'und erstellen der Konfiguration  in gsAktion beschreiben
        If gbPowerpointFlag = True Then
            'Installation beschreiben
            gsAktion = gsAktion & sPREFIX _
                & fsText(sTXT_ERZEUGEKEYHCUALLEWERTE, sRegAddInsPath, _
                gsPowerpointAddInRegistryName) & vbCr
            'Konfiguration anlegen beschreiben
            gsAktion = gsAktion & sPREFIX _
                & sTXT_SCHREIBEREGISTRY & vbCr
            'Sicherheitseinstellungen beschreiben
            If gbPowerpointSicherheit = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_SICHERHEITUNVERAENDERTLASSEN & vbCr
            Else
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_SICHERHEITANPASSEN, sRegSecurityPath) & vbCr
            End If
        End If
    Case iAUFGABE_5 'Deinstallation durchfhren und in gsAktion beschreiben
        For iZaehler = LBound(sCurrentUserAddIns) To UBound(sCurrentUserAddIns)
            If sCurrentUserAddIns(iZaehler) <> sLEER Then
                bErgebnis = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, sRegAddInsPath & "\" _
                    & sCurrentUserAddIns(iZaehler))
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_KEYHCUALLEWERTEWURDEGELOESCHT, sRegAddInsPath, _
                    sCurrentUserAddIns(iZaehler)) & vbCr
            End If
        Next iZaehler
        For iZaehler = LBound(sLocalMachineAddIns) To UBound(sLocalMachineAddIns)
            If sLocalMachineAddIns(iZaehler) <> sLEER Then
                bErgebnis = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, sRegAddInsPath & "\" _
                    & sLocalMachineAddIns(iZaehler))
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_KEYHLMALLEWERTEWURDEGELOESCHT, sRegAddInsPath, _
                    sCurrentUserAddIns(iZaehler)) & vbCr
            End If
        Next iZaehler
        'Konfiguration lschen
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_POWERPOINT)) Then
            If fbKonfiguration_loeschen(sTASKNAME_POWERPOINT) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_REGISTRYWURDEGELOESCHT & vbCr
            Else
                'Fehler: Add-In konnte nicht gelscht werden
                sText = fsText(sMSG_KONNTEREGITRYNICHTLOESCHEN)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case iAUFGABE_6 'Wenn gbPowerpointFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
        If gbPowerpointAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsPowerpointAddIn, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & gsPowerpointAddIn) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_ADDINWURDEGELOESCHT, gsPowerpointAddIn, gsInstVerzeichnis) & vbCr
                Else
                    'Fehler: Add-In konnte nicht gelscht werden
                    sText = fsText(sMSG_KONNTEADDINNICHTLOESCHEN _
                        , gsPowerpointAddIn _
                        , gsInstVerzeichnis)
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbPowerpointAddInErzeugen(sOfficeVersion, bAktion) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_ADDINWURDEERZEUGT, gsPowerpointAddIn, gsInstVerzeichnis) & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & gsPowerpointAddIn)
                'Fehler: Add-In konnte nicht erzeugt werden
                sText = fsText(sMSG_KONNTEADDINNICHTERZEUGEN _
                    , gsPowerpointAddIn _
                    , gsInstVerzeichnis)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case iAUFGABE_7 'Wenn gbPowerpointFlag gesetzt ist Installation durchfhren und in gsAktion beschreiben
        If gbPowerpointFlag = True Then
            'Installation
            bErgebnis = fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegAddInsPath & "\" _
                & gsPowerpointAddInRegistryName, "PATH", gsInstVerzeichnis & gsPowerpointAddIn, REG_SZ)
            bErgebnis = fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegAddInsPath & "\" _
                & gsPowerpointAddInRegistryName, "AUTOLOAD", "&Hffffffff", REG_DWORD)
            gsAktion = gsAktion & sPREFIX _
                & fsText(sTXT_KEYHCUALLEWERTEWURDEANGELEGT, sRegAddInsPath, _
                gsPowerpointAddInRegistryName) & vbCr
            'Konfiguration anlegen
            Call fbKonfiguration_mitAnwendungsDefaultsBelegen(sTASKNAME_POWERPOINT, True)
            gsMailToSwitch = gsInstallationsMailToSwitch
            If fbKonfiguration_schreiben(sTASKNAME_POWERPOINT) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & sTXT_REGISTRYWURDEGESCHRIEBEN & vbCr
            Else
                'Fehler: Konfiguration konnte nicht in die Registry geschrieben werden
                sText = fsText(sMSG_KONNTEREGITRYNICHTSCHREIBEN)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
            'Sicherheitseinstellungen aendern
            If gbPowerpointSicherheit = False Then
                If fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST, vSECURITYWERT_DONTTRUST, REG_DWORD) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_SICHERHEITWURDEGEAENDERT, sRegSecurityPath) & vbCr
                Else
                    'Fehler: Sicherheitseinstellungen konnten nicht verndert werden
                    sText = fsText(sMSG_KONNTESICHERHEITNICHTAENDERN _
                        , sRegSecurityPath)
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
        End If
    End Select
    
    fbPowerpoint_installieren = True

End Function

Function fbUebersetzungsdokument_installieren(iAufgabe As Integer, sOfficeVersion As String, bAktion As Byte) As Boolean
    'Die Funktion erzeugt das bersetzungs-Dokument.
    'Zuvor wird das vorhandene bersetzungs-Dokument gelscht.
    'Argumente:
    '   iAufgabe siehe Deklaration iAUFGABE_n
    '   sOfficeVersion ist die Versionsnummer von Office
    '   bAktion = Aktion beim Erzeugen des Add-In
    '       bERZEUGE_AUS_RUNTIME oder bERZEUGE_AUS_RUNTIME_MIT_TRACE
    'Global:
    '   gsInsVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim sText As String
    Const sPREFIX As String = "    Uebersetzung: "
         
    fbUebersetzungsdokument_installieren = False
            
    'Word darf nur zweimal laufen (einmal (Auto)setup.dot und einmal installation.dot)
    If iAufgabe > iAUFGABE_1 Then
        If fiAnzahlInstanzen_ermitteln(sTASKNAME_WORD) > 2 _
        And gbAnzahlWordInstanzenOKFlag = False Then
            'Fehler: Mehrere Word-Instanzen
            sText = fsText(sMSG_LAEUFTWORDMEHRFACH1)
            If MsgBox(sText _
                , vbYesNo + vbExclamation, sTITEL_INSTALLIEREN) <> vbNo Then
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                sText = fsText(sMSG_LAEUFTWORDMEHRFACH2) 'Abgebrochen
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                Exit Function
            End If
            Call fbWarten(2)
            If fiAnzahlInstanzen_ermitteln(sTASKNAME_WORD) > 2 Then
                'Fehler: Mehrere Word-Instanzen vorhanden auch nachdem eine Meldebox angezeigt und etwas Zeit vergangen ist
                sText = fsText(sMSG_LAEUFTWORDMEHRFACH3)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                gbAnzahlWordInstanzenOKFlag = True
            Else
                'Nur noch ein oder zwei Word-Instanzen vorhanden nachdem eine Meldebox angezeigt und etwas Zeit vergangen ist
                sText = fsText(sMSG_LAEUFTWORDMEHRFACH4)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
            End If
        End If
    End If
    
    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case iAUFGABE_1 'Schalter zum Erzeugen der Add-Ins setzen
        If Dir(gsInstVerzeichnis & gsUebersetzungDokument, vbNormal) = sLEER Then
            'Das bersetzungs-Dokument fehlt.
            gbUebersetzungDokErzeugenFlag = True
            gbUebersetzungDokErzeugenAenderbar = False
        Else
            'Das bersetzungs-Dokument ist schon vorhanden.
            gbUebersetzungDokErzeugenFlag = gbDebugFlag
            gbUebersetzungDokErzeugenAenderbar = gbEinRechnerInstallation
        End If
    Case iAUFGABE_3 'Wenn das Uebersetzungs-Dokument nicht vorhanden ist, Erzeugen der
        'Uebersetzungs-Dokumentes in gsAktion beschreiben
        If gbUebersetzungDokErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsUebersetzungDokument, vbNormal) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_LOESCHEDOKUMENT, gsUebersetzungDokument, gsInstVerzeichnis) _
                    & vbCr
            End If
            gsAktion = gsAktion & sPREFIX _
                & fsText(sTXT_ERZEUGEDOKUMENT, gsUebersetzungDokument, gsInstVerzeichnis) & vbCr
        End If
    Case iAUFGABE_6 'bersetzungs-Dokument erzeugen und in gsAktion beschreiben
        If gbUebersetzungDokErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsUebersetzungDokument, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & gsUebersetzungDokument) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & fsText(sTXT_DOKUMENTWURDEGELOESCHT, gsUebersetzungDokument, _
                        gsInstVerzeichnis) & vbCr
                Else
                    'Fehler: Dokument konnte nicht gelscht werden
                    sText = fsText(sMSG_KONNTEDOKUMENTNICHTLOESCHEN _
                        , gsUebersetzungDokument _
                        , gsInstVerzeichnis)
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbUebersetzungDokumentErzeugen(sOfficeVersion, bAktion) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & fsText(sTXT_DOKUMENTWURDEERZEUGT, gsUebersetzungDokument, _
                    gsInstVerzeichnis) & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & gsUebersetzungDokument)
                'Fehler: Dokument konnte nicht erzeugt werden
                sText = fsText(sMSG_KONNTEDOKUMENTNICHTERZEUGEN _
                    , gsUebersetzungDokument _
                    , gsInstVerzeichnis)
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    End Select
    
    fbUebersetzungsdokument_installieren = True

End Function

Function fsDir_ermitteln(sDir As String) As String
    'Die Funktion ermittet aus der Eingabe das Verzeichnis. Dabei werden Environment-Variable
    'ersetzt
    
    Dim lPosition As Long
    
    If sDir <> sLEER Then
        sDir = Trim(sDir)
        If Left(sDir, 1) = Chr(34) Then 'Verzeichnis ist in Anfhrungszeichen eingeschossen
            sDir = Mid(sDir, 2) 'erstes Anfhrungszeichen entfernen
            lPosition = InStr(sDir, Chr(34)) 'zweites Anfhrungszeichen suchen
            sDir = Left(sDir, lPosition - 1)
        End If
        If Right(sDir, 1) <> gsPathSeparator Then
            sDir = sDir & gsPathSeparator
        End If
        If LCase(Left(sDir, 12)) = LCase("%systemroot%") Then
            sDir = Environ("systemroot") & gsPathSeparator & Mid(sDir, 13)
        ElseIf LCase(Left(sDir, 13)) = LCase("%userprofile%") Then
            sDir = Environ("userprofile") & gsPathSeparator & Mid(sDir, 13)
        End If
        If Dir(sDir, vbDirectory) = sLEER Then 'Verzeichnis existiert nicht
            sDir = sLEER
        End If
    End If
    fsDir_ermitteln = sDir
End Function

Function fbDatei_kopieren(sVonDateiname As String, sNachDateiname As String) As Boolean
    'Die Funktion kopiert eine normale, nicht gesperrte Datei. Wenn das nicht mglich ist, wird eine
    'Meldung angezeigt. Scheibgeschtzte Dateien, versteckte Dateien, Systemdateien oder
    'Verzeichnisse werden nicht kopiert.
    'Argumente:
    '   sVonDateiname = Name der Quell-Datei
    '   sNachDateiname = Name der Ziel-Datei
    'Rckgabewert:
    '   False = Datei sVonDateiname konnte nicht nach sNachDateiname werden.
    '   True = Datei sVonDateiname wurde nach sNachDateiname kopiert.
    'Effekt
    '   Entweder wurde sVonDateiname wurde nach sNachDateiname kopiert
    '   oder es wurde eine Fehlermeldung angezeigt.
    
    Dim iDateiAttribute As Integer 'Attribute der Datei in sDateiname
    Dim iFehlerNummer As Integer 'Fehlernumer aus GetAttr()
    Dim iFehlerText As String
    
    On Error Resume Next
    iDateiAttribute = GetAttr(sVonDateiname)
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then 'Datei vorhanden
        If iDateiAttribute And vbReadOnly Then
            MsgBox fsText(sMSG_KDATEIISTSCHREIBGESCHUETZT _
                , sVonDateiname) _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbHidden Then 'wird mit Dir(sDateiname) nicht gefunden
            MsgBox fsText(sMSG_KDATEIISTVERSTECKT _
                , sVonDateiname) _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbSystem Then
            MsgBox fsText(sMSG_KDATEIISTSYSTEMDATEI _
                , sVonDateiname) _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbDirectory Then
            MsgBox fsText(sMSG_KDATEIISTVERZEICHNIS _
                , sVonDateiname) _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        End If
    Else
        MsgBox fsText(sMSG_KDATEIFEHLT _
            , sVonDateiname) _
            , vbExclamation, sTITEL_INSTALLIEREN
        fbDatei_kopieren = False
        Exit Function
    End If
    
    On Error Resume Next
    iDateiAttribute = GetAttr(sNachDateiname)
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then 'Datei vorhanden
        If iDateiAttribute And vbReadOnly Then
            MsgBox fsText(sMSG_KDATEIISTSCHREIBGESCHUETZT _
                , sNachDateiname) _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbHidden Then 'wird mit Dir(sDateiname) nicht gefunden
            MsgBox fsText(sMSG_KDATEIISTVERSTECKT _
                , sNachDateiname) _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbSystem Then
            MsgBox fsText(sMSG_KDATEIISTSYSTEMDATEI _
                , sNachDateiname) _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbDirectory Then
            MsgBox fsText(sMSG_KDATEIISTVERZEICHNIS _
                , sNachDateiname) _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        End If
    End If
    
    On Error Resume Next
    FileCopy sVonDateiname, sNachDateiname
    iFehlerNummer = Err.Number
    iFehlerText = Str(Err.Number) & sSPACE & Err.Description
    On Error GoTo 0
    If iFehlerNummer = 0 Then 'Datei vorhanden
        fbDatei_kopieren = True
    Else
        MsgBox fsText(sMSG_KDATEIKANNNICHTKOPIERTWERDEN _
            , sVonDateiname, sNachDateiname, iFehlerText) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbDatei_kopieren = False
    End If
    
End Function

Function Gib_ExcelStartupVerzeichnis() As String
    Dim iFehlerNummer As Integer
    Dim sExcelStartupVerzeichnis As String
    
    Dim oExcel As Object
       
    'Excel-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oExcel Nothing
    Set oExcel = CreateObject("Excel.Application") 'Erzeugt einen neue Instanz von Excel
    On Error GoTo 0
    If oExcel Is Nothing Then
        Gib_ExcelStartupVerzeichnis = sLEER
        Exit Function
    End If
    
    On Error Resume Next
    Gib_ExcelStartupVerzeichnis = oExcel.Application.StartupPath
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer <> 0 Then
        Gib_ExcelStartupVerzeichnis = sLEER
    End If
    
    oExcel.Quit
    Set oExcel = Nothing

End Function

Function fbSecurity_aendern(sAufgabe As String, sTaskName As String, sOfficeVersion As String) As Boolean
'SOFTWARE\MICROSOFT\OFFICE\XX.X\XXXXX\SECURITY
'               Unter Powerpoint 10.0 kann der Eintrag SECURIRY komplett fehlen
'               DWORD Level Sicherheitsstufe
'                       1 = Niedrig; 2 = Mittel; 3=Hoch
'               DWORD AccessVBOM  Zugriff auf Visual-Basic-Objekt vertrauen
'                       0 = Aus; 1 = An (Name kann fehlen)
'               DWORD DontTustInstalledFiles Allen installieren Add-Ins vertrauen
'                       0 = Vertrauen 1= Nicht vertrauen (Name kann fehlen)

    Static bSecurityVorhanden As Boolean
    Static vLevel As Variant
    Static vAccessVBOM As Variant
    Static vDontTust As Variant
    
    Dim sRegSecurityPath As String
    
    fbSecurity_aendern = True
    
    If sOfficeVersion = "8.0" Then
        Exit Function
    End If
    
    Select Case sTaskName
    Case sTASKNAME_WORD
        sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD\SECURITY"
    Case sTASKNAME_EXCEL
        sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\SECURITY"
    Case sTASKNAME_POWERPOINT
        sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\POWERPOINT\SECURITY"
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fbSecurity_aendern Case 1") _
            , vbExclamation, sTITEL_INSTALLIEREN
        Error 51
    End Select
    
    Select Case sAufgabe
    Case "ErzeugenSet"
        bSecurityVorhanden = fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sRegSecurityPath)
        vLevel = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
            sSECURITYNAME_LEVEL, NEVER_RETURN_NULL)
        vAccessVBOM = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
            sSECURITYNAME_ACCESSVBOM, NEVER_RETURN_NULL)
        vDontTust = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
            sSECURITYNAME_DONTTRUST, NEVER_RETURN_NULL)
        If Not vLevel = vSECURITYWERT_LEVEL_1 _
        And Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_LEVEL, vSECURITYWERT_LEVEL_1, REG_DWORD) = True Then
            fbSecurity_aendern = False
        End If
        If Not vAccessVBOM = vSECURITYWERT_ACCESSVBOM _
        And Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_ACCESSVBOM, vSECURITYWERT_ACCESSVBOM, REG_DWORD) = True Then
            fbSecurity_aendern = False
        End If
        If Not vDontTust = vSECURITYWERT_DONTTRUST _
        And Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_DONTTRUST, vSECURITYWERT_DONTTRUST, REG_DWORD) = True Then
            fbSecurity_aendern = False
        End If
    Case "ErzeugenReset"
        If Not vLevel = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_LEVEL, NEVER_RETURN_NULL) Then
            If vLevel = sLEER Then
                If Not fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_LEVEL) = True Then
                    fbSecurity_aendern = False
                End If
            Else
                If Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_LEVEL, vLevel, REG_DWORD) = True Then
                    fbSecurity_aendern = False
                End If
            End If
        
        End If
        If Not vAccessVBOM = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_ACCESSVBOM, NEVER_RETURN_NULL) Then
            If vAccessVBOM = sLEER Then
                If Not fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_ACCESSVBOM) = True Then
                    fbSecurity_aendern = False
                End If
            Else
                If Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_ACCESSVBOM, vAccessVBOM, REG_DWORD) = True Then
                    fbSecurity_aendern = False
                End If
            End If
        End If
        If Not vDontTust = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_DONTTRUST, NEVER_RETURN_NULL) Then
            If vDontTust = sLEER Then
                If Not fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST) = True Then
                    fbSecurity_aendern = False
                End If
            Else
                If Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST, vDontTust, REG_DWORD) = True Then
                    fbSecurity_aendern = False
                End If
            End If
        End If
        If bSecurityVorhanden = False Then
            If Not fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, sRegSecurityPath) = True Then
                fbSecurity_aendern = False
            End If
        End If
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fbSecurity_aendern Case 2") _
            , vbExclamation, sTITEL_INSTALLIEREN
        Error 51
    End Select
    
    If fbSecurity_aendern = False Then
        MsgBox fsText(sMSG_SICHERHEITSWERTNICHTAENDERBAR) _
            , vbExclamation, sTITEL_INSTALLIEREN
    End If

End Function

Function fiAnzahlInstanzen_ermitteln(sTaskName As String) As Integer
    'Die Funktion ermittel, wie viele Instanzen des Programms aus sTaskname laufen.
    'Global:
    '   Application.Tasks wird gelesen
    '   Application.Name wird gelesen
    'Rckgabewert:
    '   Anzahl der laufenden Instanzen.
    
    Dim oEinTask As Object
    Dim iFehlerNummer As Integer
    Dim bGeisterTask As Boolean
'    Dim sDokumentWindowCaption As String
    Dim sEinTaskDaten As String
    Dim sTaskDaten() As String
    Dim iZaehler As Integer

'    If Application.Documents.Count >= 1 Then
'        sDokumentWindowCaption = ActiveDocument.ActiveWindow.Caption
'    Else
'        sDokumentWindowCaption = sSPACE
'    End If
    fiAnzahlInstanzen_ermitteln = 0
    ReDim sTaskDaten(0)
    For Each oEinTask In Application.Tasks
        If UCase(Left(oEinTask.Name, Len(sTaskName))) = UCase(sTaskName) Or UCase(Right(oEinTask.Name, Len(sTaskName))) = UCase(sTaskName) Then
            bGeisterTask = False
            If sTaskName = sTASKNAME_EXCEL Then
                'Hier gibt es unter Windows 2000 / Office 2000 und Windows 98 /Office 2002
                'einen Fehler:
                'Auch eine Excel-Instanz, die schon aus dem Speicher entfernt wurde,
                'wird hier angezeigt. Dass es eine "Geister-Task" ist, findet man heraus,
                'indem man zustzlich abfragt, ob die Task gltig ist.!
                'Die Abfrage IsObjectValid(oEinTask) allein reicht nicht aus. Die Geister-Task wird
                'als Tasks erkannt, die Funktion IsObjectValid(oEinTask) liefert True, ausser, man
                'zeigt zuvor eine MsgBox an (!!!) oder aktiviert die Task. Nur dann merkt VBA, dass
                'die Task nicht existiert und - oh Wunder - IsObjectValid(oEinTask) meldet False.
                'Siehe fbExcel_installieren
                'Der Fehler ist unter Windows 2000 und Office 2000 reproduzierbar.
                'Er tritt in der Kombination Windows NT / Office 2000 nicht auf.
                'Da unsicher ist, ob er in anderen Windows- / Office-Kombinationen auch auftritt,
                'wird der Patch generell fr Excel aktiviert.
                On Error Resume Next
                oEinTask.Activate
                Application.Activate
                iFehlerNummer = Err.Number 'Wenn Err.Number <> 0 ist, dann handelt es sich um eine Geister-Task
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    bGeisterTask = True
                End If
            End If
            If sTaskName = sTASKNAME_WORD _
            And LCase(System.OperatingSystem) = "windows nt" _
            And Left(System.Version, 3) >= "5.1" Then
                'Juni 2005: Neuer Spass mit Word und Windows XP
                'Wenn man mit 'Shell()' Ghoststcript oder Ghostview entpackt, und wenn der Installationsdialog von Gs4Word offen ist,
                'dann existiert eine weitere Instanz von Word. Sie verschwindet, sobald man eine MsgBox anzeigt (!!!). Das Aktivieren der Task reicht nicht aus.
                'Der Task hat kein Dokument offen und ist mit dem "richtigen Task" identisch. Deshalb werden unter Windows XP identische Tasks (Instanzen) nur einmal gezhlt.
                sEinTaskDaten = oEinTask.Creator & " " & oEinTask.Visible & " " & oEinTask.WindowState & " " & oEinTask.Height & " " & oEinTask.Width & " " & oEinTask.Left & " " & oEinTask.Top & " " & oEinTask.Name & vbCr
                For iZaehler = LBound(sTaskDaten) To UBound(sTaskDaten)
                    If sTaskDaten(iZaehler) <> sLEER _
                    And sTaskDaten(iZaehler) = sEinTaskDaten Then
                        bGeisterTask = True
                        Exit For
                    End If
                Next iZaehler
                If bGeisterTask = False Then
                    ReDim Preserve sTaskDaten(UBound(sTaskDaten) + 1)
                    sTaskDaten(UBound(sTaskDaten)) = sEinTaskDaten
                End If
            End If
            
            If IsObjectValid(oEinTask) = True _
            And bGeisterTask = False Then
                fiAnzahlInstanzen_ermitteln = fiAnzahlInstanzen_ermitteln + 1
            End If
        End If
    Next oEinTask
'    Wenn man die Word-Anwendung aktiviert, erwischt man nicht den richtigen Task, d.h. der Installationsdialog oder eine MsgBox werden nicht angezeigt.
'    Application.Activate 'Aktiviert die Anwendung, dh. Microsoft Word
'    If sDokumentWindowCaption <> sSPACE Then
'        Windows(sDokumentWindowCaption).Activate
'    End If
'    Zu Testen
'    If sTaskName = sTASKNAME_WORD Then
'       fiAnzahlInstanzen_ermitteln = 3
'    End If
End Function


'===================================================================================================
'DUMMY-Prozeduren fr GLOB_Prozeduren
'===================================================================================================

Sub ERZEUGEN()
    'Dummy-Prozedur fr GLOB_Prozeduren
End Sub

Function fbVorlageIstAenderbar() As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageIstAenderbar = True
End Function

Function fbVorlageAnpassen(bDummy As Boolean) As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageAnpassen = True
End Function

'===================================================================================================
'Ende.
'===================================================================================================
