Attribute VB_Name = "START_Schnittstelle4Make"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   START
' Effekt:
'   Das Modul startet ein Modul des Installations-Add-In.
'   Der Name des gestarteten Moduls entspricht dem Namen dieses Add-In.
' Restriktionen:
'   Installation.dot muss vorhanden sein.
'   Unter Word 9.0 und 10.0 muss die Sicherheitsstufe niedrig oder Mittel sein, damit dieses
'   Add-In ausgefhrt werden kann.
'   Das Add-In Start_MakeAddIns.dot ist das einzige Add-In, das nicht automatisch von
'   Installation.dot aus den Sourcen erzeugt werden kann.
'   Wenn das Add-In Start_MakeAddIns.dot neu erzeugt werden soll,
'    - muss Start_MakeAddIns.dot unter einem anderen Namen kopiert werden,
'    - muss die Kopie aufgerufen werden.
' Entwicklung und Test:
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   11.12.2002  Erstellt fr Version 2.62
'   10.04.2005  berarbeitet

'===================================================================================================
'Prozeduren
'===================================================================================================
Sub AutoNew()

    Const sLEER As String = ""

    Const sTITEL_GS4WORD = "Gs4Word"
    Const sINSTALLATIONSMACRO = "MACH_Schnittstellen.AlleAddInsErzeugen"
    Const sINSTALLATIONSADDIN = "Installation.dot"
    
    Dim sMSG_KDATEIKANNNICHTKOPIERTWERDEN As String
    Dim sMSG_KEINEVERBINDUNGZUWORD As String
    Dim sMSG_INSTALLATIONSADDINFEHLT As String
    Dim sMSG_INSTALLATIONSMAKROFEHLT As String
    Dim sMSG_INSTALLATIONSMAKROSCHLIESSEN As String
    Dim sMSG_TDATEIKANNNICHTKOPIERTWERDEN As String
    
    Dim sStartMakroName As String
    Dim sInstallationsProgrammNameOriginal As String
    Dim sInstallationsProgrammNameTemp As String
    Dim iFehlerNummer As Integer
    Dim oWord As Object
    Dim vAddInName As Variant
       
    'Word maximiert anzeigen.
    'Nur dann wird die Sanduhr angezeigt und Fehlermeldungen erscheinen im Vordergrund
    Application.WindowState = wdWindowStateMaximize
           
    If LCase(Left(System.LanguageDesignation, 7)) = "deutsch" Then
        sMSG_KDATEIKANNNICHTKOPIERTWERDEN = "Das Installations-Add-In konnte nicht kopiert werden. Haben Sie es in Word geffnet?(&n)Prfen Sie die Ursache und versuchen Sie es erneut."
        sMSG_KEINEVERBINDUNGZUWORD = "Konnte keine Verbindung zu Word herstellen.(&n)Ist Microsoft-Word installiert?"
        sMSG_INSTALLATIONSADDINFEHLT = "Kann das erforderliche Add-In nicht laden. Ist es vorhanden?"
        sMSG_INSTALLATIONSMAKROFEHLT = "Kann das Word-Makro nicht ausfhren. Ist es im Add-In vorhanden?"
        sMSG_INSTALLATIONSMAKROSCHLIESSEN = "Kann das Add-In nicht schliessen. Wurde es schon geschlossen?"
        sMSG_TDATEIKANNNICHTKOPIERTWERDEN = "Das Installations-Add-In wurde nicht erzeugt und die temporre Installations-Add-In konnte nicht kopiert werden. Da scheint ein greres Problem vorzuliegen."
    Else
        sMSG_KDATEIKANNNICHTKOPIERTWERDEN = "Das Installations-Add-In konnte nicht kopiert werden. Haben Sie es in Word geffnet?(&n)Prfen Sie die Ursache und versuchen Sie es erneut."
        sMSG_KEINEVERBINDUNGZUWORD = "Could not communicate with Word.(&n)Is Microsoft Word installed?"
        sMSG_INSTALLATIONSADDINFEHLT = "Cannot load the necessary Add-in. Is it present?"
        sMSG_INSTALLATIONSMAKROFEHLT = "Cannot execute the Word macro. Is the Add-in available?"
        sMSG_INSTALLATIONSMAKROSCHLIESSEN = "Cannot close the Add-in. Is it already closed?"
        sMSG_TDATEIKANNNICHTKOPIERTWERDEN = "Das Installations-Add-In wurde nicht erzeugt und die temporre Installations-Add-In konnte nicht kopiert werden. Da scheint ein greres Problem vorzuliegen."
    End If
    
    sInstallationsProgrammNameOriginal = _
        ThisDocument.Path & Application.PathSeparator & sINSTALLATIONSADDIN
    sInstallationsProgrammNameTemp = _
        ThisDocument.Path & Application.PathSeparator & "Tmp_" & sINSTALLATIONSADDIN
    
    'Hinweise lschen
    Selection.WholeStory
    Selection.Delete
    
    'Neuen Hinweis anzeigen
    sStartMakroName = ActiveDocument.AttachedTemplate.Name
    If LCase(Right(sStartMakroName, 4)) = ".dot" Then
        sStartMakroName = Left(sStartMakroName, Len(sStartMakroName) - 4)
    End If
    Selection.Collapse Direction:=wdCollapseEnd
    Selection.InsertAfter (sTITEL_GS4WORD & " - " & sStartMakroName)
    Selection.InsertAfter (vbCrLf)
    Selection.Font.Size = 14
    Selection.Font.Bold = True
    Selection.Collapse Direction:=wdCollapseEnd
    Selection.InsertAfter (vbCrLf & "Bitte warten...")
    Selection.InsertAfter (vbCrLf & "Please wait...")
    Selection.InsertAfter (vbCrLf)
    Selection.Font.Size = 12
    Selection.Font.Bold = False
    Selection.Font.Size = 12
    Selection.LanguageID = wdNoProofing
    Selection.Collapse Direction:=wdCollapseEnd 'reduziert die Auswahl auf das Ende
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox sMSG_KEINEVERBINDUNGZUWORD, vbExclamation, sTITEL_GS4WORD
        Exit Sub
    End If
    
    'Installations-Add-In kopieren, damit das Original neu erzeugt werden kann.
    On Error Resume Next
    FileCopy sInstallationsProgrammNameOriginal, sInstallationsProgrammNameTemp
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If Not iFehlerNummer = 0 Then
        MsgBox sMSG_KDATEIKANNNICHTKOPIERTWERDEN _
            & vbCr & "(" & sInstallationsProgrammNameOriginal & ")" _
            , vbExclamation, sTITEL_GS4WORD
        Exit Sub
    End If
    
    'Temporres Installations-Add-In laden
    On Error Resume Next
    oWord.AddIns.Add FileName:=sInstallationsProgrammNameTemp, Install:=True
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer <> 0 Then
        MsgBox sMSG_INSTALLATIONSADDINFEHLT _
            & vbCr & "(" & sInstallationsProgrammNameTemp & ")" _
            , vbExclamation, sTITEL_GS4WORD
    Else
        'Installations-Add-In minimiert ausfhren
        oWord.Visible = True 'Word Applikation anzeigen, bei False sieht man nichts!
        oWord.WindowState = wdWindowStateMinimize
        On Error Resume Next
        oWord.Run MacroName:=sINSTALLATIONSMACRO
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If iFehlerNummer <> 0 Then
            MsgBox sMSG_INSTALLATIONSMAKROFEHLT _
                & vbCr & "(" & sInstallationsProgrammNameTemp _
                & " - " & sINSTALLATIONSMACRO & ")" _
                , vbExclamation, sTITEL_GS4WORD
        Else
            'Installations-Add-In entladen
            On Error Resume Next
            oWord.AddIns(sInstallationsProgrammNameTemp).Delete
            iFehlerNummer = Err.Number
            On Error GoTo 0
            'Wenn die aufgerufene Word-Instanz schon beendet wurde, ist das OK
            'If iFehlerNummer <> 0 Then
            '    MsgBox sMSG_INSTALLATIONSMAKROSCHLIESSEN _
            '        & vbCr & "(" & sInstallationsProgrammName & ")" _
            '        , vbExclamation, sTITEL_GS4WORD
            'End If
        End If
    End If
    
    'Word beenden
    'Wenn die aufgerufene Word-Instanz schon beendet wurde, ist das OK
    On Error Resume Next
    oWord.Quit
    Set oWord = Nothing
    On Error GoTo 0
    
    'Wenn das Installations-Add-In fehlt, muss das temporre Add-In wieder zurckkopiert werden
    If Dir(sInstallationsProgrammNameOriginal, vbNormal) = sLEER Then
        On Error Resume Next
        FileCopy sInstallationsProgrammNameTemp, sInstallationsProgrammNameOriginal
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If Not iFehlerNummer = 0 Then
            MsgBox sMSG_TDATEIKANNNICHTKOPIERTWERDEN _
                & vbCr & "(" & sInstallationsProgrammNameOriginal & ")" _
                , vbExclamation, sTITEL_GS4WORD
            Exit Sub
        End If
    Else
        'Wenn ein Installations-Add-In vorhanden ist, kann das temporre Add-In gelscht werden
        Kill sInstallationsProgrammNameTemp
    End If
    Application.Quit SaveChanges:=wdDoNotSaveChanges
       
End Sub

Function fsTraceZeileAusgeben(sTraceZeile As String) As Boolean
    'Dummy Funktion zum Trace, falls dieser aktiv ist.

End Function

'===================================================================================================
'Ende.
'===================================================================================================




