Attribute VB_Name = "XLS_Prozeduren"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   XLS_Prozeduren
' Effekt beim Start von Excel:
'   Das Modul erstellt in dieser Vorlage beim Aufruf von Excel ...
'       1. in der aktiven Menleiste ein Men "PDF".
'       2. in der Symbolleiste "Standard" einen Button "PDF", wenn dies in der Konfiguration vorgesehen ist.
' Effekt beim Aufruf von PDF > Erzeugen:
'   Das Modul erstellt aus der aktuellen Excel-Arbeitsmappe eine PDF-Datei. Dazu erzeugt es eine
'   gleichnamige Postscript-Datei mit der Endung .ps und eine gleichnamige PDF-Datei mit der Endung
'   .pdf. Die Postscript-Datei wird wieder gelscht.
' Effekt beim Aufruf von "PDF > Info":
'   Das Modul zeigt Informationen ber sich an.
' Restriktionen:
'   Alle Module und UserForms XLS_ und GLOB_ mssen vorhanden sein.
'   Microsoft Office 9.0 Object Library ist erforderlich fr fbVorlageAnpassen()
'   Dieses Add-In darf nicht schreibgeschtzt sein. Es muss "Gs4Wordxxx.dot" heissen. Dabei ist xxx
'   ein beliebiger, optionaler Zusatz.
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   10.10.2002  Erweitet fr Version 2.60
'   14.05.2004  fbActivePrinterAuf_gsDruckerName_setzen gendert
'   17.04.2006  fbOfficeDatei_gespeichert funktioniert jetz bei geschtzten Tabellen

'===================================================================================================
' Portierung von Word nach Excel und Powerpoint
'===================================================================================================
' Kommentare:
'   Word -> Excel -> Powerpoint
'   Word-Dokument -> Excel-Arbeitsmappe Powerpoint-Prsentation
'   Dokument -> Arbeitsmappe -> Prsentation
' Schlselworte:
'   Documents.Count -> Workbooks.Count -> Presentations.Count
'   ActiveDocument -> ActiveWorkbook -> ActivePresentation
'   ThisDocument -> ThisWorkbook -> For Each cbEinAddin In AddIns
'   ActivePrinter -> ActivePrinter -> ActivePresentation.PrintOptions.ActivePrinter

'===================================================================================================================
'Deklarationen
'===================================================================================================================

' Die folgenden Konstanen steuern die Verarbeitung in der Prozedur fbVorlageAnpassen
'-----------------------------------------------------------------------------------
Private Const sVORLAGE_ACTION_ERZEUGEN As String = "XLS_Prozeduren.ERZEUGEN"
    'Modul- und Prozedurname fr das Erzeugen einer PDF-Datei.
Private Const sVORLAGE_ACTION_INFO As String = "XLS_Prozeduren.INFO"
    'Modul- und Prozedurname fr die Anzeige der Informationen ber das Add-In.
Private Const sVORLAGE_ACTION_KONFIGURIEREN As String = "GLOB_Prozeduren.KONFIGURIEREN"
    'Modul- und Prozedurname fr das Konfigurieren des Add-In.
Private Const sVORLAGE_ACTION_DOKUMENTATION As String = "GLOB_Prozeduren.DOKU_ANFANG"
    'Modul- und Prozedurname fr die Anzeige der Dokumentation des Add-In.
Private Const sVORLAGE_ACTION_MAILTO As String = "GLOB_Prozeduren.MAILEN"
    'Modul- und Prozedurname fr das Erzeugen einer PDF-Datei.
Public Const sVORLAGE_ACTION_SPRACHAUSWAHL As String = "GLOB_Prozeduren.SPRACHAUSWAHL"
    'Modul- und Prozedurname fr die Auswahl einer Sprache.
Private Const lVORLAGE_BUTTON_FACEID As Long = 2144
    'Symbol-ID fr den PDF-Button: 481=Herz, 276=Trauriger Smilie, 2144 = Zahnrder
Private Const lVORLAGE_BUTTON_BEFOREID As Long = 21
    'ID eines Buttons in der Symboleiste Standard. Vor diesem Button wird der PDF-Button eingefgt.
    '2520=Neu, 23=ffnen, 3 = Speichern, 2521=Drucken, 109=Seitenansicht, 2566=Rechtscheibung und Grammatik,
    '21=Ausschneiden,, ..., 984=Hilfe
    'Wenn die Nummer ungltig oder 0 ist, wird der PDF-Button vor den letzten Button eingefgt.

'===================================================================================================================
'Deklarationen fr den Zugriff auf die Registry mit fsRegistry_SZWertLesen
'===================================================================================================================
'Private Const REG_NONE = 0
Private Const REG_SZ As Long = 1
'Private Const REG_EXPAND_SZ = 2
'Private Const REG_BINARY = 3
'Private Const REG_DWORD As Long = 4
'Private Const REG_DWORD_LITTLE_ENDIAN = 4
'Private Const REG_DWORD_BIG_ENDIAN = 5
'Private Const REG_LINK = 6
'Private Const REG_MULTI_SZ = 7

Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_USERS = &H80000003

'Private Const REG_BINARY_LAENGE = 1
'Private Const REG_DWORD_LAENGE = 4

Private Const ERROR_NONE = 0
'Private Const ERROR_BADDB = 1
'Private Const ERROR_BADKEY = 2
'Private Const ERROR_CANTOPEN = 3
'Private Const ERROR_CANTREAD = 4
'Private Const ERROR_CANTWRITE = 5
'Private Const ERROR_OUTOFMEMORY = 6
'Private Const ERROR_ARENA_TRASHED = 7
'Private Const ERROR_ACCESS_DENIED = 8
Private Const ERROR_INVALID_PARAMETERS = 87
'Private Const ERROR_NO_MORE_ITEMS = 259

Private Const KEY_QUERY_VALUE = &H1
'Private Const KEY_SET_VALUE = &H2
'Private Const KEY_ALL_ACCESS = &H3F

'Private Const REG_OPTION_NON_VOLATILE = 0


    
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal ulOptions As Long, _
    ByVal samDesired As Long, _
    phkResult As Long) _
    As Long
Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As String, _
    lpcbData As Long) _
    As Long
Private Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Long, _
    lpcbData As Long) _
    As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpValueName As String, _
    lpcbValueName As Long, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Any, _
    lpcbData As Long) _
    As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" ( _
    ByVal hKey As Long) _
    As Long

'===================================================================================================================
'Vorlage anpassen beim Start von Excel
'===================================================================================================================

Function fbSprachtexteErzeugen(sSprachcode As String, sInstVerzeichnis As String) As Boolean

    Call fbGLOB_SprachtexteErzeugen(sSprachcode, sInstVerzeichnis)
    Call fbXLS_SprachtexteErzeugen(sSprachcode, sInstVerzeichnis)
    fbSprachtexteErzeugen = True

End Function

Function fbVorlageAnpassen(bUnbedingtSpeichernFlag As Boolean) As Boolean
    'Die Prozedur erstellt in dieser Vorlage beim Aufruf ...
    '    1. in der aktiven Menleiste ein Men "PDF".
    '    2. in der Symbolleiste "Standard" einen Button "PDF", wenn dies in der Konfiguration vorgesehen ist.
    'Wenn all das schon richtig eingestellt war, und bUnbedingterUpdateFlag = False ist, dann geschieht nichts.
    'Argumente:
    '   bUnbedingterUpdateFlag
    '       Thrue = Die Vorlage wird unbedingt gespeichert.
    '       False = Die Vorlage wird nur dann gespeichert, wenn das Menue oder die Buttons verndert wurde.
    'Global:
    '   g... aus GLOB_Prozeduren werden gelesen
    'Restriktionen:
    '   Die Konfiguration muss gelesen worden sein.
    'Rckgabewert:
    '   True = das Men und ggf. die Symbolleiste "Standard" wurden angepasst.
    'Effekt
    '   ggf. wurde Menleiste und ggf. Symbolleiste verndert.
    
    Const sVORLAGE_TAG As String = "Gs4WordXLS20011229"
        'Identifikation der PDF-Mens und -Buttons. Dieser Tag-String darf nie gendert werden.
    
    Dim cbAktiveMenueLeiste As CommandBar
    Dim cbEinControl As CommandBarControl
    Dim cbEinButton As CommandBarButton
    Dim iPosition As Integer
    Dim iZaehler As Integer
    Dim lAnzahlPDFMenues As Long
    Dim lAnzahlPDFButtons As Long
    
    ' (1) Konfiguration lesen und prfen
    '-----------------------------------
    'Call fbKonfiguration_lesen(sTASKNAME_EXCEL)
        
    ' (2) CustomizationContext setzen
    '--------------------------------
    ' Entfllt in Excel

    Set cbAktiveMenueLeiste = CommandBars.ActiveMenuBar
    
    ' (3) Prfen, ob Menu oder Button verndert werden muss
    '------------------------------------------------------
    'Prfen ob das PDF-Men schon vorhanden ist.
    'Die Routine muss auch dann fehlerfrei arbeiten, wenn mehrere PDF-Mens vorhanden sind!
    lAnzahlPDFMenues = 0
    For Each cbEinControl In cbAktiveMenueLeiste.Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then 'ein PDF-Menu gefunden
            lAnzahlPDFMenues = lAnzahlPDFMenues + 1
        End If
    Next cbEinControl
    
    'Prfen ob der PDF-Button schon vorhanden ist.
    'Die Routine muss auch dann fehlerfrei arbeiten, wenn mehrere PDF-Buttons vorhanden sind!
    lAnzahlPDFButtons = 0
    For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then 'einen PDF-Button gefunden
            lAnzahlPDFButtons = lAnzahlPDFButtons + 1
        End If
    Next cbEinControl
    
    'Fertig wenn nicht unbedingt gespeichert werden muss und das PDF-Men schon vorhanden ist und der PDF-Button richtig an oder aus ist.
    If bUnbedingtSpeichernFlag = False _
    And lAnzahlPDFMenues = 1 _
    And ((gbButtonFlag = False And lAnzahlPDFButtons = 0) Or (gbButtonFlag = True And lAnzahlPDFButtons = 1)) Then
        Exit Function 'Sollzustand erreicht -> fertig
    End If
    'Es kann nur dann weitergehen, wenn die Vorlage nicht schreibgeschtzt ist.
    ' Entfllt in Excel
    
    ' (4) Aktive Menleiste um das PDF-Men erweitern
    '------------------------------------------------
    'Alle ggf. vorhandenen PDF-Mens lschen
    For Each cbEinControl In cbAktiveMenueLeiste.Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then
            cbEinControl.Delete
        End If
    Next cbEinControl
   
    'Men "PDF" einfgen
    Set cbEinControl = cbAktiveMenueLeiste.Controls.Add(Type:=msoControlPopup, _
        Before:=cbAktiveMenueLeiste.Controls.Count, Temporary:=True)
    With cbEinControl
        .Caption = sVORLAGE_MENU_CAPTION
        .Tag = sVORLAGE_TAG
    End With

    'Befehl "Erzeugen" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_ERZEUGEN_CAPTION
        .OnAction = sVORLAGE_ACTION_ERZEUGEN
    End With
    
    'Befehl "Mailen" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_MAILTO_CAPTION
        .OnAction = sVORLAGE_ACTION_MAILTO
        If gsMailToSwitch = sMAILTOSWITCH_AUS Then
            .Enabled = False
        End If
    End With
    
    'Befehl "Konfigurieren" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_KONFIGURIEREN_CAPTION
        .OnAction = sVORLAGE_ACTION_KONFIGURIEREN
    End With
        
    'Befehl "Dokumentation" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_DOKUMENTATION_CAPTION
        .OnAction = sVORLAGE_ACTION_DOKUMENTATION
        If gsDokuAufruf = sLEER Then
            .Enabled = False
        End If
    End With
        
    'Befehl "Info" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_INFO_CAPTION
        .OnAction = sVORLAGE_ACTION_INFO
    End With
        
    ' (5) Symbolleiste "Standard" um den PDF-Button erweitern
    '--------------------------------------------------------
    If lAnzahlPDFButtons > 0 Then
        'Alle vorhandenen PDF-Buttons lschen
        For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
            If cbEinControl.Tag = sVORLAGE_TAG Then
                cbEinControl.Delete
            End If
        Next cbEinControl
    End If
    
    If gbButtonFlag = True Then
        'Einen PDF-Button einfgen.
        'Zuerst nach der Position des Buttons suchen, vor dem der PDF-Button stehen soll
        iZaehler = 0
        iPosition = CommandBars(sVORLAGE_SYMBOLLEISTE).Controls.Count
        For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
            iZaehler = iZaehler + 1
            If cbEinControl.Id = lVORLAGE_BUTTON_BEFOREID Then
                iPosition = iZaehler
                Exit For
            End If
        Next cbEinControl
        Set cbEinControl = CommandBars(sVORLAGE_SYMBOLLEISTE).Controls.Add(Type:=msoControlButton, Id:=1, _
            Before:=iPosition, Temporary:=True)
        With cbEinControl
            .FaceId = lVORLAGE_BUTTON_FACEID
            '.BeginGroup = True 'wanns scheee maacht
            .Caption = sVORLAGE_BUTTON_CAPTION
            .Style = msoButtonAutomatic
            .Tag = sVORLAGE_TAG
            .TooltipText = sVORLAGE_BUTTON_TOOLTIPTEXT
            .OnAction = sVORLAGE_ACTION_ERZEUGEN
        End With
    End If
    
    ' (6) Vorlage speichern
    '----------------------
    ' Entfllt in Excel
    
    fbVorlageAnpassen = True
    
End Function
    
'===================================================================================================================
'Men "PDF > Info"
'===================================================================================================================
    
Private Sub INFO()
    'Die Prozedur zeigt eine Box mit Informationen ber das Add-In an.
    'Effekt
    '   Die Info-Box wurde angezeigt.
    
    Call fbInfo_anzeigen(ThisWorkbook.FullName)
    
End Sub
    
'===================================================================================================
'Men "PDF > Erzeugen..."
'===================================================================================================

Sub ERZEUGEN()
Attribute ERZEUGEN.VB_Description = "pdf"
Attribute ERZEUGEN.VB_ProcData.VB_Invoke_Func = "p\n14"
    'Effekt
    '   Ggf. wurden ein oder zwei Dialoge gefhrt oder eine Fehlermeldung angezeigt.
    '   Ggf. wurde eine Postscript-Datei gelscht.
    '   Ggf. wurde  eine PDF-Datei erzeugt.
    
    On Error GoTo Fehler_aufgetreten:
 
    Dim sLogDateiName As String 'Name der Log-Datei mit absolutem Pfad
    Dim sPDFDateiName As String 'Name der PDF-Datei mit absolutem Pfad
    Dim sPSDateiName As String 'Name der Postscript-Datei mit absolutem Pfad
       
    gsMailtoDateiName = sLEER
    
    ' (1) Office-Datei prfen
    '------------------------
    If fbOfficeDatei_gespeichert() = False Then
       Exit Sub
    End If
       
    ' (2) Konfiguration lesen und prfen
    '-----------------------------------
    Call fbKonfiguration_lesen(sTASKNAME_EXCEL) 'Dabei auch gsAusgabeMedienListe() fllen
    If fbKonfiguration_testen(sTASKNAME_EXCEL) = False Then
        MsgBox fsText(sMSG_KONFIGUNVOLLSTAENDIG) _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Sub
    End If
    
    ' (3) Name der Postscript- PDF- und Log-Datei ermitteln
    '------------------------------------------------------
    gsBasisDateiName = fsBasisDateiName_ermitteln(gsSymbDateiName)
    If gsBasisDateiName = sLEER Then
        Exit Sub
    End If
    
    ' (4) Einstellungen_waehlen
    '--------------------------
    If fbEinstellungen_waehlen(sTASKNAME_EXCEL) = False Then
       Exit Sub
    End If
            
    ' (5) Namen der Postscript- PDF- und LogDateien prfen und Dateien lschen, wenn vorhanden
    '-----------------------------------------------------------------------------------------
    sLogDateiName = gsBasisDateiName & sLOG
    sPSDateiName = gsBasisDateiName & sPS
    sPDFDateiName = gsBasisDateiName & sPDF
    If fbDatei_pruefen_loeschen(sLogDateiName) = False Then
        Exit Sub
    End If
    If fbDatei_pruefen_loeschen(sPSDateiName) = False Then
        Exit Sub
    End If
    If fbDatei_pruefen_loeschen(sPDFDateiName) = False Then
        Exit Sub
    End If
                        
    ' (6) Postscript-Datei erzeugen
    '------------------------------
    If fbPSDatei_erzeugen(ActiveWorkbook.FullName, sPSDateiName) = False Then
        Exit Sub
    End If
    
    ' (7) Postscript-Datei ergaenzen
    '-------------------------------
    If fbPSDatei_ergaenzen(sPSDateiName) = False Then
        Exit Sub
    End If
    
    ' (8) PDF-Datei erzeugen
    '-----------------------
    If fbPDFDatei_erzeugen(sLogDateiName, sPSDateiName, sPDFDateiName, gsAusgabeMedium) = False Then
        Exit Sub
    End If
    
    ' (9) Log-Datei wieder lschen
    '------------------------------------
    If gbLogDateiLoeschenFlag Then
        If fbDatei_loeschen(sLogDateiName) = False Then
            Exit Sub
        End If
    End If
    
    ' (10) Postscript-Datei wieder lschen
    '------------------------------------
    If gbPSDateiLoeschenFlag = True Then
        If fbDatei_loeschen(sPSDateiName) = False Then
            Exit Sub
        End If
    End If
    
    ' (11) PDF-Datei anzeigen
    '------------------------
    Call fbPDFDatei_anzeigen(sPDFDateiName)
    
    ' (12) PDF-Datei zum mailen merken
    '---------------------------------
    gsMailtoDateiName = sPDFDateiName
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisWorkbook.Name _
        , "ERZEUGEN" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER
    
End Sub

'===================================================================================================
'Alle Private Funktionen und Subroutinen, die nur von der Subroutine ERZEUGEN verwendet werden.
'===================================================================================================

Private Function fbOfficeDatei_gespeichert() As Boolean
    'Die Funktion prft, ob eine Office-Datei geffnent ist und ob es jemals gespeichert wurde.
    'Zustzlich wird be Excel geprft, ob die aktuelle Tabelle nicht leer ist
    'Global:
    '   ActiveWorkbook.Path
    '   ActiveWorkbook.Name
    '   Workbooks.Count
    '   gsPathSeparator wird gelesen
    'Rckgabewert:
    '   False = Office-Datei ist nicht gespeichert
    '   True = Office-Datei ist gespeichert und hat eine Pfad
    'Effekt
    '   Ggf. wurde eine Fehlermeldung angezeigt.
    
    Dim iTabelleLeerFlag As Integer
    Dim iAntwort
    Dim oAktuelleZelle, oLetzteZelle As Object
    
    fbOfficeDatei_gespeichert = False
    
    If Workbooks.Count < 1 Then  'Es ist keine Office-Datei geffnet
        MsgBox fsText(sMSG_KEINEOFFICEDATEI) _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Function
    End If
    
    If ActiveWorkbook.Name = sLEER _
    Or ActiveWorkbook.Path = sLEER _
    Or flLetztesVorkommen_suchen(ActiveWorkbook.Name, ".") <= 0 Then
        'Die geffnete Office-Datei ist nicht gespeichert
        MsgBox fsText(sMSG_OFFICEDATEINICHTGESPEICHERT _
            , CurDir & gsPathSeparator & ActiveWorkbook.Name) _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Function
    End If
   
    iTabelleLeerFlag = 99
    
    On Error Resume Next
    'Falls keine Tabelle sondern ein Diagramm aktiv ist, bleibt iTabelleLeerFlag unverndert auf 99
    iTabelleLeerFlag = IsEmpty(Cells(1, 1).Value)
    On Error GoTo 0
    
    ' Bei iTabelleLeerFlag = 99 ist ActiveSheet keine Tabelle.
    ' Bei iTabelleLeerFlag = 0 ist ActiveSheet eine Tabelle, deren Zelle A1 nicht leer ist.
    ' Bei iTabelleLeerFlag = -1 ist ActiveSheet eine Tabelle, deren Zelle A1 leer ist. Desbalb wird
    ' hier noch einmal geprft, ob die Tabelle wirklich leer ist. Da das bei grossen, sehr leeren
    ' Tabellen lange dauert, werden nur die ersten 256 Zeilen berprft.
    If iTabelleLeerFlag = -1 Then
        On Error Resume Next
        'Wenn das Blatt geschtzt ist, liefert SpecialCells eine Laufzeitfehler
        Set oLetzteZelle = Cells.SpecialCells(xlCellTypeLastCell)
        On Error GoTo 0
        If oLetzteZelle Is Nothing Then
            'Wenn das Blatt geschtzt ist, fix auf 256 Zeilen und 24 Spalten setzen
            Set oLetzteZelle = Cells(256, 24)
        End If
        'Falls die letzte Spalte oder Zeile verborgen ist, wird sie nur bercksichtigt, wenn die
        'nchste Spalte oder Zeile ebenfalls berprft wird.
        If oLetzteZelle.Column < 256 Then
            Set oLetzteZelle = oLetzteZelle.Offset(0, 1)
        End If
        If oLetzteZelle.Row < 255 Then ' Maximal 65536
            Set oLetzteZelle = oLetzteZelle.Offset(1, 0)
        Else ' Maximal 256 Zeilen berprfen sonst dauert es zu lange
            Set oLetzteZelle = Cells(256, oLetzteZelle.Column)
        End If
        For Each oAktuelleZelle In Worksheets(ActiveSheet.Name).Range(Cells(1, 1), _
        oLetzteZelle.Address)
            If Not IsEmpty(oAktuelleZelle.Value) _
            Or Not oAktuelleZelle.Value = "" Then
               fbOfficeDatei_gespeichert = True
               Exit Function
            End If
        Next oAktuelleZelle
                
        If oLetzteZelle.Row < 256 Then
            MsgBox fsText(sMSG_EXCELTABELLEISTLEER) _
                , vbExclamation, sTITEL_ERZEUGEN
        Else
            If MsgBox(fsText(sMSG_EXCELTABELLEWAHRSCHEINLICHLEER) _
                , vbYesNo, sTITEL_ERZEUGEN) = vbYes Then
                fbOfficeDatei_gespeichert = True
            End If
        End If
    Else
        fbOfficeDatei_gespeichert = True
    End If
    

End Function

Private Function fbEinstellungen_waehlen(sTaskName As String) As Boolean
    'Die Funktion zeigt die UserForm fr die nderbaren Einstellungen an.
    'Die genderten Werte werden in den globalen Variablen gespeichert.
    'Falls der BasisDateiName verndert wurde, wird er neu erzeugt und geprft.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Global:
    '   gbDialogFlag wird gelesen
    '   gbEinTeilobjektFlag wird ggf. verndert
    '   gsAusgabeMedium wird ggf. verndert
    '   gsBasisDateiName wird ggf. verndert
    '   giDialogEffekt wird gesetzt
    'Rckgabewert:
    '   False = Die Auswahl der Einstellungen wurde abgebrochen oder der genderte BasisDateiName
    '           ist fehlerhaft
    '   True = Die Einstellungen wurden ausgewhlt
    'Effekt
    
    If gbDialogFlag = True Then 'Einstellungen im Dialog ndern
        GLOB_UserForm.Show
        fbEinstellungen_waehlen = giDialogEffekt
        
        If giDialogEffekt = True Then
            gsBasisDateiName = fsBasisDateiName_ermitteln(gsBasisDateiName)
            If gsBasisDateiName = sLEER Then 'genderter BasisDateiName ist fehlerhaft
                fbEinstellungen_waehlen = False
            End If
        End If
    Else
        fbEinstellungen_waehlen = True
    End If

End Function

Private Function fbPSDatei_erzeugen(sOfficeDateiName As String, sPSDateiName As String) As Boolean
    'Erzeugt aus sOfficeDateiName die Postscriptdatei sPSDateiName. Wenn das nicht mglich ist, wird
    'eine Meldung angezeigt.
    'Argumente:
    '   sOfficeDateiName = Dateiname der aktiven Office-Datei
    '   sPSDateiName = Dateiname der Postscript-Datei
    'Global:
    '   gbEinTeilobjektFlag wird gelesen
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht erzeugt werden.
    '   True = Postscript-Datei sPSDateiName wurde erzeugt.
    'Effekt
    '   Entweder wurde eine Postscript-Datei erzeugt
    '   oder eine Fehlermeldung angezeigt.
    
    Dim bPSDateiLocked As Boolean
    Dim sStandardDruckerName As String 'Name des aktuell eingesteller Druckers mit on-Klausel
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePrinter
    
    sStandardDruckerName = ActivePrinter
    If fbActivePrinterAuf_gsDruckerName_setzen() = False Then
        MsgBox fsText(sMSG_PSDRUCKERUNBEKANNT _
            , gsPSDruckerName) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
        Exit Function
    End If
        
    'Jetzt drucken. In Word und Powerpoint wird erzwungen, dass das Add-In erst dann weiterluft,
    'wenn die Postscript-Datei vollstndig erzeugt wurde. Das ist in Excel nicht mglich!
    
    SendKeys fsSendKeysString_erzeugen(sPSDateiName) & "{ENTER}"
    
    Select Case gsPrintSwitch
    Case sPRINTSWITCH_EXCEL_ARBEITSMAPPE 'Die ganze Arbeitsmappe ausgeben
        ActiveWorkbook.PrintOut , PrintToFile:=True, Collate:=True
    Case sPRINTSWITCH_EXCEL_TABELLE 'Nur die aktuelle Tabelle ausgeben
        ActiveSheet.PrintOut , PrintToFile:=True, Collate:=True
    Case sPRINTSWITCH_EXCEL_TABELLENAUSWAHL ' Nur markierten Tabellen ausgeben
        ActiveWorkbook.Windows(1).SelectedSheets.PrintOut , PrintToFile:=True, Collate:=True
        'Window(1) ist immer das aktuelle Fenster
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fbPSDatei_erzeugen") _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
        
    'In Excel ist im Druckdialog der Schalter "Ausgabe in Datei umleiten" jetzt unverndert
    
    'Standard-Drucker wieder setzen
    If sStandardDruckerName <> ActivePrinter Then
        On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde (na ja)
        ActivePrinter = sStandardDruckerName
        On Error GoTo 0
    End If
    
    If Dir(sPSDateiName, vbNormal) <> sLEER Then
        'Dir liefert den ersten gefundenden Dateinamen oder sLEER
        If FileLen(sPSDateiName) > 0 Then
            'Die PS-Datei muss auch einen Inhalt haben
            fbPSDatei_erzeugen = True
            Exit Function
        End If
    End If
    
    'Ab hier nur noch Fehlerhandling
    If InStr(sPSDateiName, ",") > 0 Then
        MsgBox fsText(sMSG_PSDATEIMITKOMMA _
            , sPSDateiName) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
    Else
        MsgBox fsText(sMSG_PSDATEINICHTERZEUGT _
            , sPSDateiName _
            , gsPSDruckerName) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
    End If

End Function
    
Private Function fbPSDatei_ergaenzen(sPSDateiName As String) As Boolean
    'Die Funktion ergnzt die Postscriptdatei sPSDateiName um Dokumenteigenschaften und Lesezeichen
    'Global:
    '   gbPdfmarkFlag wird gelesen
    'Argumente:
    '   sPSDateiName = Dateiname der Postscript-Datei
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht ergnzt werden.
    '   True = Postscript-Datei sPSDateiName wurde ergnzt.
    'Effekt
    '   Ggf. wurde die Postscript-Datei verndert
    '   oder eine Fehlermeldung angezeigt.
    
    Dim sAuthor As String
    Dim sCreationDate As String
    Dim sCreator As String
    Dim sTitle As String
    Dim sSubject As String
    Dim sKeywords As String
    Dim sModDate As String
    Dim lTablesOfContents As Long
    Dim bUeberschriften As Boolean
    Dim sPageHeight As Single
    Dim sPageWidth As Single
    Dim lPaperSize As Long
    Dim lOrientation As Long 'xlLandscape oder xlPortrait
    
    If gbPdfmarkFlag = False Then 'Keine pdfmarks verwenden
        fbPSDatei_ergaenzen = True
        Exit Function
    End If
    
    On Error Resume Next ' falls ein Element nicht definiert ist
    sAuthor = ActiveWorkbook.BuiltinDocumentProperties("Author")
    sCreationDate = Format(ActiveWorkbook.BuiltinDocumentProperties("Creation date"), "yyyymmDdhhnnss")
    sCreator = ActiveWorkbook.BuiltinDocumentProperties("Application name")
    sTitle = ActiveWorkbook.BuiltinDocumentProperties("Title")
    sSubject = ActiveWorkbook.BuiltinDocumentProperties("Subject")
    sKeywords = ActiveWorkbook.BuiltinDocumentProperties("Keywords")
    sModDate = Format(ActiveWorkbook.BuiltinDocumentProperties("Last save time"), "yyyymmDdhhnnss")
    lTablesOfContents = 0
    bUeberschriften = False
    lPaperSize = ActiveSheet.PageSetup.PaperSize
    lOrientation = ActiveSheet.PageSetup.Orientation
    On Error GoTo 0
    
    sPageHeight = 0
    sPageWidth = 0
    ' 1 Punkt = 0.35 mm
    ' 1 Zoll = 72 Punkte = 25,4 mm
    Select Case lOrientation
    Case xlPortrait  'Hochformat
        Select Case lPaperSize
        Case xlPaperLetter   'US-Letter (8-1/2 x 11 Zoll)
            sPageHeight = 11 * 72
            sPageWidth = 8.5 * 72
        Case xlPaperLegal    'US-Legal (8 1/2 x 14 Zoll)
            sPageHeight = 14 * 72
            sPageWidth = 8.5 * 72
        Case xlPaperExecutive    'US-Executive (7 1/2 x 10 1/2 Zoll)
            sPageHeight = 10.5 * 72
            sPageWidth = 7.5 * 72
        Case xlPaperA3   'A3 (297 x 420 mm)
            sPageHeight = 420 / 0.35
            sPageWidth = 297 / 0.35
        Case xlPaperA4   'A4 (210 x 297 mm)
            sPageHeight = 297 / 0.35
            sPageWidth = 210 / 0.35
        Case xlPaperA5   'A5 (148 x 210 mm)
            sPageHeight = 210 / 0.35
            sPageWidth = 148 / 0.35
        Case xlPaperB4   'B4 (250 x 354 mm)
            sPageHeight = 354 / 0.35
            sPageWidth = 250 / 0.35
        Case xlPaperB5   'B5 (182 x 257 mm)
            sPageHeight = 257 / 0.35
            sPageWidth = 182 / 0.35
        End Select
    Case xlLandscape  'Querformat
        Select Case lPaperSize
        Case xlPaperLetter   'US-Letter (8-1/2 x 11 Zoll)
            sPageHeight = 8.5 * 72
            sPageWidth = 11 * 72
        Case xlPaperLegal    'US-Legal (8 1/2 x 14 Zoll)
            sPageHeight = 8.5 * 72
            sPageWidth = 14 * 72
        Case xlPaperExecutive    'US-Executive (7 1/2 x 10 1/2 Zoll)
            sPageHeight = 7.5
            sPageWidth = 10.5
        Case xlPaperA3   'A3 (297 x 420 mm)
            sPageHeight = 297 / 0.35
            sPageWidth = 420 / 0.35
        Case xlPaperA4   'A4 (210 x 297 mm)
            sPageHeight = 210 / 0.35
            sPageWidth = 297 / 0.35
        Case xlPaperA5   'A5 (148 x 210 mm)
            sPageHeight = 148 / 0.35
            sPageWidth = 210 / 0.35
        Case xlPaperB4   'B4 (250 x 354 mm)
            sPageHeight = 250 / 0.35
            sPageWidth = 354 / 0.35
        Case xlPaperB5   'B5 (182 x 257 mm)
            sPageHeight = 182 / 0.35
            sPageWidth = 257 / 0.35
        End Select
    End Select
        
    fbPSDatei_ergaenzen = fbPSDateiPdfmark_ergaenzen(sPSDateiName, _
    sAuthor, sCreationDate, sCreator, sTitle, _
    sSubject, sKeywords, sModDate, lTablesOfContents, bUeberschriften, _
    sPageHeight, sPageWidth)
    
End Function

Private Function fbActivePrinterAuf_gsDruckerName_setzen() As Boolean
    'Die Funktion setzt ActivePrinter auf gsDruckerName.
    'In VBA fr Excel muss dabei auch der Port angegeben werden. Dazu muss das Fllwort "on", "auf"
    'oder ein anderes Word je nach Sprache ermittelt werden.
    'Die Funktion ermittelt das Fllwort aus dem AcrivePrinter.
    'Es werden zwei unterschiedliche Verfahren verwendet:
    'a) Fllwort zwischen DruckerName und PortName aus Application.ActivePrinter ermitteln.
    '   Dieses Verfahren setzt voraus, dass der PortName in ActivePrinter mit dem PortNamen in der
    '   Registry bereinstimmt. Das ist z.B. beim Netgear-PrintServer nicht der Fall.
    'b) Jedes Wort in Application.ActivePrinter daraufhin untersuchen, ob es das Fllwort ist.
    '
    '
    'Diese Verfahren setzen voraus, dass der PortName zum Drucker in gsPSDruckername mit dem
    'PortNamen in der Registry bereinstimmt. Das ist z.B. beim Port GS4WORD nicht der Fall.
    'Dedshalb werden alle mglichen Portnamen ausprobiert.

    'Global:
    '   gsPSDruckerName wird gelesen
    'Rckgabewert:
    '   True = Der Drucker aus gsDruckerName ist der ActivePrinter.
    '   False = Der Drucker aus gsDruckerName konnte nicht zum ActivePrinter
    '           gemacht werden. Der ActivePronter ist unverndert.
    'Effekt
    '   ActivePrinter verndert
    
    Const sDRUCKERKEY As String = "System\CurrentControlSet\Control\Print\Printers\"
    Const sPORT As String = "Port"
    Const sPORTKEY As String = "Software\Microsoft\Windows NT\CurrentVersion\Ports\"
    Const sFUELLWORT1 As String = "auf"
    Const sFUELLWORT2 As String = "on"
    Static ssPSDruckerNameMitPort As String
    
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePrinter
    Dim sDruckerNameMitPort As String
    Dim sDruckerName As String
    Dim lPos As Long
    Dim lPosVon As Integer
    Dim lPosBis As Integer
    Dim lIndex As Long
    ReDim sPortNamen(0) As String 'Tabelle mit PortNamen, die passen knnten.
    ReDim sFuellworte(0) As String 'Tabelle mit Fuellworten, die passen knnten.
    Dim vPortName As Variant
    Dim vFuellwort As Variant
    Dim sPortName As String
    Dim sFuellwort As String
    
    If ssPSDruckerNameMitPort <> sLEER _
    And gsPSDruckerName <> sLEER _
    And Left(ssPSDruckerNameMitPort, Len(gsPSDruckerName)) = gsPSDruckerName Then
        On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde
        Application.ActivePrinter = ssPSDruckerNameMitPort
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If iFehlerNummer = 0 Then
            'fertig - Drucker in
            fbActivePrinterAuf_gsDruckerName_setzen = True
            Exit Function
        End If
    End If
    
    ssPSDruckerNameMitPort = sLEER
    
    '(1) Alle Portnamen aus der Registry in eine Tabelle lesen
    sPortName = fsRegistry_SZWertLesen(HKEY_LOCAL_MACHINE, sDRUCKERKEY & gsPSDruckerName, sPORT)
    If sPortName <> sLEER _
    And gsPSDruckerName <> sLEER Then
        sPortNamen(UBound(sPortNamen)) = sPortName
        ReDim Preserve sPortNamen(UBound(sPortNamen) + 1)
    End If
    lIndex = 0
    Do While True
        vPortName = fvRegistry_WertNummerLesen(HKEY_LOCAL_MACHINE, sPORTKEY, lIndex)
        If IsNull(vPortName) = True Then 'fertig
            Exit Do
        End If
        sPortName = CStr(vPortName)
        sPortNamen(UBound(sPortNamen)) = sPortName
        ReDim Preserve sPortNamen(UBound(sPortNamen) + 1)
        lIndex = lIndex + 1
    Loop
    
    '(2) Alle mglichen Fllworte ermitteln
    sDruckerNameMitPort = Application.ActivePrinter
    lPos = InStr(sDruckerNameMitPort, sSPACE)
    Do While lPos > 0 'Solange suchen bis lPos = 0 ist; dh. Space nicht mehr gefunden wurde
        sDruckerName = Left(sDruckerNameMitPort, lPos - 1)
        'Prfen, ob sDruckerName in der Registry eingetragen ist
        sPortName = fsRegistry_SZWertLesen(HKEY_LOCAL_MACHINE, sDRUCKERKEY & sDruckerName, _
            sPORT)
        sFuellworte(0) = sLEER
        If sPortName <> sLEER _
        And Right(sDruckerNameMitPort, Len(sPortName)) = sPortName _
        And Len(sDruckerNameMitPort) - lPos - Len(sPortName) + 1 > 0 Then
            sFuellworte(0) = Mid(sDruckerNameMitPort, lPos + 1, Len(sDruckerNameMitPort) - lPos - Len(sPortName) - 1)
            'Vertrauen ist gut - Kontrolle ist besser
            If sDruckerName & sSPACE & sFuellworte(0) & sSPACE & sPortName = sDruckerNameMitPort Then
                ' Jetzt steht in sFuellworte das Fllwort und in sPortName der Port
                ' aus Application.ActivePrinter
                ReDim Preserve sFuellworte(UBound(sFuellworte) + 1)
                Exit Do
            End If
        End If
        lPos = InStr(lPos + 1, sDruckerNameMitPort, sSPACE)
    Loop
    sFuellworte(UBound(sFuellworte)) = sFUELLWORT1
    ReDim Preserve sFuellworte(UBound(sFuellworte) + 1)
    sFuellworte(UBound(sFuellworte)) = sFUELLWORT2
    
    '(3) Alle Fuellworte und PortNamen der Reihe nach durchprobieren
    For Each vFuellwort In sFuellworte()
        sFuellwort = CStr(vFuellwort)
        For Each vPortName In sPortNamen()
            sPortName = CStr(vPortName)
            sDruckerNameMitPort = gsPSDruckerName & sSPACE & sFuellwort & sSPACE & sPortName
            On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde
            Application.ActivePrinter = sDruckerNameMitPort
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer = 0 Then
                fbActivePrinterAuf_gsDruckerName_setzen = True
                ssPSDruckerNameMitPort = sDruckerNameMitPort
                Exit Function
            End If
        Next vPortName
    Next vFuellwort
    
    'Das war wohl nichts - Jetzt hat der Anwender ein ernsthaftes Problem
    fbActivePrinterAuf_gsDruckerName_setzen = False

End Function

Private Function fsRegistry_SZWertLesen(lKeyName As Long, sPfadName As String, sWertName As String) _
As String
    'Die Funktion liest einen SZ-Wert aus der Registry zum Key lKeyName und Pfad sPfadName
    'Global:
    '   Konstante des Moduls (siehe oben)
    'Rckgabewert:
    '   sLeer   = Kein Wert in der Registry gefunden
    '   xx..xx  = Wert aus der Registry
    'Effekt
    '   -
    
    Dim lHandleNr As Long
    Dim sSzWert As String
    Dim lSzWertLaenge As Long
    Dim lReturnCode As Long
    Dim lWertType As Long
    Dim sWert As String
    
    lReturnCode = RegOpenKeyEx(lKeyName, sPfadName, 0, KEY_QUERY_VALUE, lHandleNr)
    If lReturnCode = ERROR_NONE Then
        lReturnCode = RegQueryValueExNULL(lHandleNr, sWertName, 0&, lWertType, 0&, lSzWertLaenge)
        If lReturnCode = ERROR_NONE Then
            If lWertType = REG_SZ Then
                sSzWert = String(lSzWertLaenge, 0)
                lReturnCode = RegQueryValueExString(lHandleNr, sWertName, 0&, lWertType, sSzWert, lSzWertLaenge)
                If lReturnCode = ERROR_NONE Then
                    sWert = Left$(sSzWert, lSzWertLaenge - 1)
                End If
            Else
                lReturnCode = ERROR_INVALID_PARAMETERS
            End If
        End If
    End If
    RegCloseKey (lHandleNr)
    
    If lReturnCode = ERROR_NONE Then
        fsRegistry_SZWertLesen = sWert
    Else
        fsRegistry_SZWertLesen = sLEER
    End If
    
End Function

Public Function fvRegistry_WertNummerLesen(lKeyName As Long, sPfadName As String, _
lWertNummer As Long, Optional bNullReturn As Boolean = True) As Variant
    'lWertNummer beginnt bei 0
    Dim lHandleNr As Long
    Dim lReturnCode As Long
    Dim sWertName As String
    Dim lWertNameLaenge As Long
    Dim lSzWertLaenge As Long 'wird nicht ausgewertet
    Dim lWertType As Long 'wird nicht ausgewertet
    
    lReturnCode = RegOpenKeyEx(lKeyName, sPfadName, 0, KEY_QUERY_VALUE, lHandleNr)
    If lReturnCode = ERROR_NONE Then
        lWertNameLaenge = 2000
        sWertName = String(lWertNameLaenge, 0)
        lReturnCode = RegEnumValue(lHandleNr, lWertNummer, sWertName, lWertNameLaenge, 0&, lWertType, 0&, lSzWertLaenge)
        If lReturnCode = ERROR_NONE Then
            sWertName = Left(sWertName, lWertNameLaenge)
        End If
    End If
    RegCloseKey (lHandleNr)
    
    If lReturnCode = ERROR_NONE Then
        fvRegistry_WertNummerLesen = sWertName
    Else
        If bNullReturn = True Then
            fvRegistry_WertNummerLesen = Null
        Else
            fvRegistry_WertNummerLesen = sLEER
        End If
    End If
    
End Function

Private Function fsSendKeysString_erzeugen(sString As String) As String
    'Die Funktion erzeugt aus sName einen gltigen SendKey-String.
    'Das Pluszeichen (+), Caret-Zeichen (^), Prozentzeichen (%), die Tilde (~), die Klammern ( ),
    'die Eckige Klammern ([ ]) und die geschweiften Klammern ({ }) mssen bei der SendKeys-Anweisung
    'in geschweifte Klammern eingeschlossen werden.
    'Argumente:
    '   sString = String der mittels SendKey gesendet werden soll
    'Rckgabewert:
    '   xx..xx = erweiterter String, der von SendKey verarbeitet werden kann
    'Effekt
    '   keiner

    Dim lStringPos, lUmzZeichenPos As Long 'Zhler
    Dim sEinZeichen As String
    Dim sUmzusetzendeZeichen As String 'String mit Zeichen, die in {}eingeschlossen werden mssen.
    sUmzusetzendeZeichen = "{}+^%~()[]"
           
    fsSendKeysString_erzeugen = sLEER

    For lStringPos = 1 To Len(sString)
        sEinZeichen = Mid(sString, lStringPos, 1)
        lUmzZeichenPos = InStr(1, sUmzusetzendeZeichen, sEinZeichen, vbTextCompare)
        If lUmzZeichenPos > 0 Then
            fsSendKeysString_erzeugen = fsSendKeysString_erzeugen & "{" & sEinZeichen & "}"
        Else
            fsSendKeysString_erzeugen = fsSendKeysString_erzeugen & sEinZeichen
        End If
    Next lStringPos

End Function

'===================================================================================================
'Alle Funktionen und Subroutinen, die von der Subroutine ERZEUGEN
'und von ComboBoxEinTeilobjektFlag_Change verwendet werden.
'===================================================================================================

Function fsBasisDateiName_ermitteln(sSymbDateiName As String) As String
    'Die Funktion ermittelt aus sSymbDateiName den BasisDateinamen mit Pfad fr die PS- und
    'PDF-Datei. Dabei werden auch Namenszustze bercksichtigt.
    'Argumente
    '   sSymbDateiName = Symbolischer Dateiname
    'Global:
    '   ActiveWorkbook.Path = Pfad des aktiven Office-Dokuments
    '   ActiveWorkbook.Name = Dateiname des aktiven Office-Dokuments
    '   gsPathSeparator wird gelesen
    '   gbEinTeilobjektFlag wird gelesen
    'Rckgabewert:
    '   sLEER = Es konnte kein Dateiname erzeugt werden
    '   "xxx...xxx" = BasisDateiname der Datei.
    'Effekt
        
    Dim sErweitererSymbDateiName As String 'Vollstndiger symbolischer Dateiname
    Dim sBasisName As String 'Name des aktiven Office-Dokuments ohne Pfad und Extension
    Dim lLaenge As Long
    Dim sPfadName As String
    Dim sNamenszusatz As String
    Dim vEinSheet As Variant
    
    If Left(sSymbDateiName, 2) = "\\" _
    Or (Asc(LCase(Left(sSymbDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sSymbDateiName, 1))) <= 122 _
    And Mid(sSymbDateiName, 2, 1) = ":" _
    And Mid(sSymbDateiName, 3, 1) = gsPathSeparator) Then '"\\XXX" und "C:\XXX" unverndert lassen
        sErweitererSymbDateiName = sSymbDateiName
    ElseIf Asc(LCase(Left(sSymbDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sSymbDateiName, 1))) <= 122 _
    And Mid(sSymbDateiName, 2, 1) = ":" Then '"C:XXX" wird zu "C:\aaa\XXX"
        sPfadName = CurDir(Left(sSymbDateiName, 2))
        If Right(sPfadName, 1) = gsPathSeparator Then
            sErweitererSymbDateiName = sPfadName & Mid(sSymbDateiName, 3)
        Else
            sErweitererSymbDateiName = sPfadName & gsPathSeparator & Mid(sSymbDateiName, 3)
        End If
    ElseIf Left(sSymbDateiName, 1) = gsPathSeparator Then
        '"\XXX" wird zu "D:\XXX" oder \\server\freigabe\XXX
        If Left(ActiveWorkbook.Path, 2) = "\\" Then '\\freigabe\server\
            lLaenge = InStr(InStr(3, ActiveWorkbook.Path, gsPathSeparator) + 1, _
                ActiveWorkbook.Path, gsPathSeparator) - 1
            If lLaenge < 3 Then 'Auch bei einem Fehler geht es weiter
                lLaenge = 0
            End If
        Else
            lLaenge = 2
        End If
        sErweitererSymbDateiName = Left(ActiveWorkbook.Path, lLaenge) & sSymbDateiName
    Else '"XXX" wird zu "D:\aaa\XXX"
        sErweitererSymbDateiName = ActiveWorkbook.Path & gsPathSeparator & sSymbDateiName
    End If
    
    Select Case gsPrintSwitch
    Case sPRINTSWITCH_EXCEL_ARBEITSMAPPE 'Die ganze Arbeitsmappe ausgeben
        sNamenszusatz = sLEER
    Case sPRINTSWITCH_EXCEL_TABELLE 'Nur die aktuelle Tabelle ausgeben
        sNamenszusatz = sBasisName & "_" & ActiveSheet.Name
    Case sPRINTSWITCH_EXCEL_TABELLENAUSWAHL ' Nur markierte Tabellen ausgeben
        For Each vEinSheet In ActiveWorkbook.Windows(1).SelectedSheets
            sNamenszusatz = sBasisName & "_" & vEinSheet.Name
        Next vEinSheet
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fsBasisDateiName_ermitteln") _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
        
    sBasisName = Left(ActiveWorkbook.Name, _
        flLetztesVorkommen_suchen(ActiveWorkbook.Name, ".") - 1) & sNamenszusatz
    fsBasisDateiName_ermitteln = fsSymbDateiName_umsetzen(sErweitererSymbDateiName, sBasisName, sLEER)
    
End Function

'===================================================================================================
'DUMMY-Prozeduren fr GLOB_Prozeduren
'===================================================================================================

Function fbVorlageIstAenderbar() As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageIstAenderbar = True
End Function

'===================================================================================================
'DUMMY-Prozeduren fr TECH_Prozeduren
'===================================================================================================

Function fsDruckerPort_ermitteln(sPSDruckerName As String) As String
    fsDruckerPort_ermitteln = sLEER
End Function

'===================================================================================================
'Ende.
'===================================================================================================


